Package: GeneticsPed
Title: Pedigree and genetic relationship functions
Description: Classes and methods for handling pedigree data. It
  also includes functions to calculate genetic relationship measures
  as relationship and inbreeding coefficients and other utilities.
  Note that package is not yet stable. Use it with care!
Author: Gregor Gorjanc and David A. Henderson <DNADavenator@GMail.Com>,
  with code contributions by Brian Kinghorn and Andrew Percy
  (see file COPYING)
Maintainer: David Henderson <DNADavenator@GMail.Com>
URL: http://rgenetics.org
License: LGPL (>= 2.1) | file LICENSE
biocViews: Genetics
Version: 1.73.0
Depends: R (>= 2.4.0), MASS
Imports: gdata, genetics
Date: 2007-09-20
Suggests: RUnit, gtools
git_url: https://git.bioconductor.org/packages/GeneticsPed
git_branch: devel
git_last_commit: 41bd03e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: yes
Packaged: 2025-10-30 21:15:40 UTC; biocbuild

### nIndividual.R
###------------------------------------------------------------------------
### What: Number of individuals in a Pedigree
### $Id: nIndividual.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-10-15 13:52:12 ggorjan>
###------------------------------------------------------------------------

nIndividual <- function(x, col=NULL, extend=TRUE, drop=TRUE)
{
  x <- checkAttributes(x)
  if(is.null(col)) col <- attr(x, ".subject")
  subject <- attr(x, ".subject")
  if(col == subject & extend) x <- extend(x)
  if(is.factor(x[[col]])) {
    if(is.list(unusedLevels(x))) {
      if(drop) {
        warning("unused levels in 'col' were dropped")
        x <- dropLevels(x)
      } else {
        warning("there are unused levels in 'col'")
      }
    }
    return(nlevels(x[[col]]))
  } else {
    if(col == subject) { ## subjects are all known
      return(length(x[[col]]))
    } else { ## ascendants might be unknown
      tmp <- unique(x[[col]])
      return(length(tmp[!is.na(tmp)]))
    }
  }
}

dropLevels <- function(x)
{
  x <- checkAttributes(x)
  col <- c(attr(x, ".subject"), attr(x, ".ascendant"))
  x[, col] <- lapply(x[, col], factor)
  x
}

###------------------------------------------------------------------------
### nIndividual.R ends here

### doRUnit.R
###------------------------------------------------------------------------
### What: Run unit tests with RUnit
### $Id$
### Time-stamp: <2007-04-19 00:32:42 ggorjan>
###------------------------------------------------------------------------

## unit tests will not be done if RUnit is not available
if(require("RUnit", quietly=TRUE)) {

  ## --- Setup ---

  pkg <- "GeneticsPed"
  if(Sys.getenv("RCMDCHECK") == "FALSE") {
    ## Path to unit tests for standalone running under Makefile (not R CMD check)
    ## PKG/tests/../inst/unitTests
    path <- file.path(getwd(), "..", "inst", "unitTests")
  } else {
    ## Path to unit tests for R CMD check
    ## PKG.Rcheck/tests/../PKG/unitTests
    path <- system.file(package=pkg, "unitTests")
  }
  cat("\nRunning unit tests\n")
  print(list(pkg=pkg, getwd=getwd(), pathToUnitTests=path))

  library(package=pkg, character.only=TRUE)

  ## --- Testing ---

  ## Define tests
  testSuite <- defineTestSuite(name=paste(pkg, "unit testing"),
                                          dirs=path)
  ## Run
  tests <- runTestSuite(testSuite)

  ## Default report name
  pathReport <- file.path(path, "report")

  ## Report to stdout and text files
  cat("------------------- UNIT TEST SUMMARY ---------------------\n\n")
  printTextProtocol(tests, showDetails=FALSE)
  printTextProtocol(tests, showDetails=FALSE,
                    fileName=paste(pathReport, "Summary.txt", sep=""))
  printTextProtocol(tests, showDetails=TRUE,
                    fileName=paste(pathReport, ".txt", sep=""))

  ## Report to HTML file
  ## NOTE from H. Pages <hpages@fhcrc.org> from the Gentleman Lab (Oct 16,
  ##   2008): I've added the test below because printHTMLProtocol() seems
  ##   to be broken in RUnit 0.4.19 on the OS X platform.
  if (substring(R.Version()$os, 1, 6) != "darwin") 
    printHTMLProtocol(tests, fileName=paste(pathReport, ".html", sep=""))

  ## Return stop() to cause R CMD check stop in case of
  ##  - failures i.e. FALSE to unit tests or
  ##  - errors i.e. R errors
  tmp <- getErrors(tests)
  if(tmp$nFail > 0 | tmp$nErr > 0) {
    stop(paste("\n\nunit testing failed (#test failures: ", tmp$nFail,
               ", #R errors: ",  tmp$nErr, ")\n\n", sep=""))
  }
} else {
  warning("cannot run unit tests -- package RUnit is not available")
}

###------------------------------------------------------------------------
### doRUnit.R ends here

### prune.R
###------------------------------------------------------------------------
### What: Prune pedigree - code
### $Id$
### Time-stamp: <2007-08-19 17:53:16 ggorjan>
###------------------------------------------------------------------------

### {{{ prune

prune <- function(x, id, father, mother, unknown=NA, testAdd=NULL,
                          verbose=FALSE)
{
  ### {{{ --- Checks & setup ---

  if(!is.data.frame(x)) stop("'x' must be a data.frame")

  if(missing(id) | missing(father) | missing(mother))
    stop("'id', 'father', and 'mother' column names must be given")

  if(!(id %in% names(x)))
    stop("column name specified in 'id' does not exist in 'x'")
  if(!(father %in% names(x)))
    stop("column name specified in 'father' does not exist in 'x'")
  if(!(mother %in% names(x)))
    stop("column name specified in 'mother' does not exist in 'x'")

  ## Duplicates
  if(length(unique(x[, id])) != nrow(x)) {
    tmp <- table(x[, id])
    tmp <- names(tmp[tmp > 1])
    stop(paste("there are duplicated entries for 'id';\ncheck individual(s):",
               paste(tmp, collapse=", ")))
  }

  ## Any ID unknown
  test <- is.na(x[, id]) | x[, id] %in% unknown
  if(any(test)) {
    tmp <- which(test)
    stop(paste("'id' must be known; check row(s):",
               paste(tmp, collapse=", ")))
  }

  ## Set unknown to NA
  setToUnknown <- FALSE
  if(any(!(unknown %in% NA))) {
    x[, c(father, mother)] <- unknownToNA(x=x[, c(father, mother)],
                                          unknown=unknown)
    setToUnknown <- TRUE
  }

  ## Is pedigree extended
  test <- x[, father] %in% x[, id] | is.na(x[, father])
  if(any(!test)) {
    tmp <- x[which(test), father]
    stop(paste("pedigree must be extended; father(s) do not appear as individuals:",
               paste(tmp, collapse=", ")))
  }
  test <- x[, mother] %in% x[, id] | is.na(x[, mother])
  if(any(!test)) {
    tmp <- x[which(test), mother]
    stop(paste("pedigree must be extended; mother(s) do not appear as individuals:",
               paste(tmp, collapse=", ")))
  }

  ## TODO: GeneticsPed use of extend

  ## testAdd
  if(!is.null(testAdd)) {
    if(!is.logical(testAdd))
      stop("'testAdd' must be logical i.e. TRUE/FALSE")
    if(length(testAdd) != nrow(x))
      stop("length of 'testAdd' must equal number of rows in 'x'")
  }

  if(verbose) cat("... all checks and setup passed\n")

  ### }}}
  ### {{{ --- Real work ---

  ### {{{ pruneAny

  pruneAny <- function()
  {
    ## Founders i.e. unknown father and mother
    testF <- is.na(x[, father])
    testM <- is.na(x[, mother])
    testFM <- testF & testM
    ## x[testFM, ] # these are potential candidates for removal, but
    ##             # only if they have less than 2 or no descendants

    ## Number of first descendants
    tabF <- table(x[, father])
    tabM <- table(x[, mother])
    testNF <- tabF > 1
    testNM <- tabM > 1
    testNFM <- !(x[, id] %in% c(names(tabF[testNF]), names(tabM[testNM])))

    ## x[testFM, ]           # founders
    ## x[testFM & testNFM, ] # founders with less than 2 or no descendants

    ## Additional test
    ## x[testFM & testNFM & testAdd, ] # founders, < 2, and additional test

    ## Return
    if(is.null(testAdd)) {
      testFM & testNFM
      ## test <- testFM & testNFM
    } else {
      testFM & testNFM & testAdd
      ## test <- testFM & testNFM & testAdd
    }
  }

  ### }}}
  ### {{{ loop

  iter <- 1
  cont <- TRUE
  while(cont) {
    test <- pruneAny()
    if(any(test)) {
      ## Remove individual(s)
      ind <- x[test, id]
      x <- x[!test, ]
      if(!is.null(testAdd)) testAdd <- testAdd[!test]
      ## Set to unknown where these individuals appeared as father/mother
      x[x[, father] %in% ind, father] <- NA
      x[x[, mother] %in% ind, mother] <- NA
      ## Report
      if(verbose) {
        cat(paste("... ", iter, ": removed ", length(ind), " individual(s)\n", sep=""))
        cat(ind, "\n")
      }
      iter <- iter + 1
      cont <- TRUE
    } else {
      cont <- FALSE
    }
  }

  ### }}}

  ### }}}
  ### {{{ --- Return ---

  ## Set NA back to unknown
  if(setToUnknown) {
    x[, c(father, mother)] <- NAToUnknown(x=x[, c(father, mother)],
                                          unknown=unknown[1])
    if(length(unknown) > 1)
      cat(paste("Beware: unknown identification set to", unknown[1], "\n"))
  }

  x
  ### }}}
}

### }}}
### {{{ Dear Emacs
### Local variables:
### folded-file: t
### end:
### }}}

###------------------------------------------------------------------------
### prune.R ends here

### generation.R
###------------------------------------------------------------------------
### What: Calculate generation value
### $Id: generation.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-09-30 17:33:41 ggorjan>
###------------------------------------------------------------------------

generation <- function(x, start=1, generationOrder=NULL)
{
  ## --- Setup ---

  subject <- attr(x, ".subject")
  idInput <- as.character(x[[subject]])  ## for sorting back

  ## Pedigree must be sorted, extended and unknowns must be NA
  x <- checkAttributes(x, sorted=TRUE, extended=TRUE, unknownNA=TRUE)

  N <- nrow(x)
  ascendant <- attr(x, ".ascendant")
  ascendantN <- length(ascendant)
  ascendantLevel <- attr(x, ".ascendantLevel")
  generation <- vector(mode="numeric", length=N)
  names(generation) <- x[[subject]]
  if(is.null(generationOrder)) generationOrder <- attr(x, ".generationOrder")

  ## --- Machine ---

  for(i in 1:N) {
    founder <- isFounder(x[i, ])
    if(founder) {
      generation[i] <- start
    } else {
      genlist <- NULL
      for(j in 1:ascendantN) {
        k <- x[i, ascendant[j]]
        if(is.na(k)) {
          genlist <- c(genlist, start)
        } else {
          k <- which(x[[subject]] %in% k)
          genlist <- c(genlist, generation[k] + ascendantLevel[j] - 1)
        }
      }
      generation[i] <- max(genlist) + 1
    }
  }

  if(generationOrder != "increasing")
    generation <- abs(generation - max(generation)) + start

  ## --- End ---

  generation[idInput]
}

"generation<-" <- function(x, generationOrder=NULL, col=NULL, value)
{
  ## --- Setup ---

  generAttr <- attr(x, ".generation")
  generOrdAttr <- attr(x, ".generationOrder")
  colTest <- is.null(col)
  ordTest <- is.null(generationOrder)

  if(is.na(generAttr) & colTest) attr(x, ".generation") <- col <- "generation"
  if(!is.na(generAttr) & colTest) col <- attr(x, ".generation")
  if(!is.na(generAttr) & !colTest) { ## rename column with col
    colNamesT <- names(x)
    colNamesT[colNamesT == generAttr] <- col
    colnames(x) <- colNamesT
    attr(x, ".generation") <- col
  }

  if(is.na(generOrdAttr) & ordTest) attr(x, ".generationOrder") <- generationOrder <- "increasing"
  if(!is.na(generOrdAttr) & !ordTest) attr(x, ".generationOrder") <- generationOrder

  ## --- Apply ---

  x[[col]] <- value

  x
}

###------------------------------------------------------------------------
### generation.R ends here

### geneContribution.R
###------------------------------------------------------------------------
### What: Gene contribution or proportion of genes in pedigree by individual
### $Id: geneContribution 895 2006-06-16 14:28:51Z dnadave $
### Time-stamp: <2006-10-01 02:44:37 ggorjan>
###------------------------------------------------------------------------

geneContribution <- function(x, relative=TRUE)
{
  ## --- Setup ---

  subject <- attr(x, ".subject")
  ascendant <- attr(x, ".ascendant")
  idInput <- as.character(x[[subject]]) ## for sort-back

  ## Pedigree must be sorted, extended and unknowns must be NA
  x <- checkAttributes(x, sorted=TRUE, extended=TRUE,
                                     unknownNA=TRUE)
  z <- rep(1, times=nrow(x))
  names(z) <- x[[subject]]

  ascSex <- attr(x, ".ascendantSex")
  ascProb <- table(ascSex)
  multi <- ascProb[ascProb > 1]
  cont <- rep(0.5, times=length(ascSex))
  names(cont) <- ascSex

  ## --- The machine ---

  for(i in rev(seq(along=x[[subject]]))) {
    k <- which(x[[subject]] %in% x[i, ascendant])
    if(length(k) > 0) {
      cont1 <- cont[!isUnknown(x[i, ], col=ascendant)]
      if(length(cont1) > 2) {
        test <- names(cont1) %in% names(multi)
        cont1[test] <- cont1[test] / multi
      }
      z[k] <- z[k] + cont1 * z[i]
    }
  }

  z <- z - 1
  if(relative)
    z <- z / nrow(x)

  ## --- End ---

  z[idInput]
}

###------------------------------------------------------------------------
### geneContribution.R ends here

### getSlot.R
###------------------------------------------------------------------------
### What: Retrieve slot values from the pedigree
### $Id$
### Time-stamp: <2007-09-20 12:44:37 ggorjan>
###------------------------------------------------------------------------

getIdName          <- function(x) attr(x, ".subject") ## FIXME: change to id
getId              <- function(x) x[, getIdName(x)]

getAscendantName   <- function(x) attr(x, ".ascendant")
getAscendant       <- function(x) x[, getAscendantName(x)]

getFatherName      <- function(x) attr(x, ".ascendant")[1]
getFather          <- function(x) x[, getFatherName(x)]

getMotherName      <- function(x) attr(x, ".ascendant")[1]
getMother          <- function(x) x[, getMotherName(x)]

getFamilyName      <- function(x) attr(x, ".family")
getFamily          <- function(x) x[[getFamilyName(x)]]

getSexName         <- function(x) attr(x, ".sex")
getSex             <- function(x) x[[getSexName(x)]]

getDtBirthName     <- function(x) attr(x, ".dtBirth")
getDtBirth         <- function(x) x[[getDtBirthName(x)]]

getGenerationName  <- function(x) attr(x, ".generation")
getGeneration      <- function(x) x[[getGenerationName(x)]]

getAscendantSex    <- function(x) attr(x, ".ascendantSex")
getAscendantLevel  <- function(x) attr(x, ".ascendantLevel")
getGenerationOrder <- function(x) attr(x, ".generationOrder")
getColClass        <- function(x) attr(x, ".colClass")
getChecked         <- function(x) attr(x, ".checked")
getExtended        <- function(x) attr(x, ".extended")
getSorted          <- function(x) attr(x, ".sorted")
getCoded           <- function(x) attr(x, ".coded")
getUnknown         <- function(x) attr(x, ".unknown")

###------------------------------------------------------------------------
### getSlot.R ends here

### writePedigree.R
###------------------------------------------------------------------------
### What: Write pedigree in various formats
### $Id: writePedigree.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-09-30 01:11:07 ggorjan>
###------------------------------------------------------------------------

## LINKAGE in PRE-MAKEPED format --> this should be alpha and omega as
## Mega2, has lots of possibilities to convert to other formats, but we
## need mapLevels() before to get integer codes - is mapLevels() fast
## enough for large scale?

writePreMakeped <- function()
{
  ## do we need write.fwf here?
}

## MENDEL FORMAT --> should be easy due to CSV so I write it here

writeMendel <- function(x, alleleSep="-")
{
  x <- checkAttributes(x)
  if(is.na(attr(x, ".family"))) family(x) <- ???

  ## Genotypes ?

  x <- NAToUnknown(x, unknown="")
  write.csv(x)
}

###------------------------------------------------------------------------
### writePedigree.R ends here

### TDT.R
###------------------------------------------------------------------------
### What: Gene and gamete flow and mendelian sampling covariance matrices
### $Id: TDT.R 1193 2007-04-06 11:35:47Z ggorjan $
### Time-stamp: <2007-09-07 00:49:04 ggorjan>
###------------------------------------------------------------------------

### {{{ Gene flow matrix - T

###------------------------------------------------------------------------

geneFlowT <- function(x, sort=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  ascendant <- getAscendantName(x)
  if(length(ascendant) > 2)
    stop("no method for pedigree with more than two ascendants")
  if(sort) idOrig <- as.character(getId(x))  # for sort-back

  ## Pedigree must be extended and sorted
  x <- checkAttributes(x, extended=TRUE, sorted=TRUE)

  n <- nrow(x)
  ret <- matrix(0, n, n)         # n*n matrix
  diag(ret) <- 1                 # diagonal = 1
  rownames(ret) <- colnames(ret) <- getId(x)

  asc1 <- as.character(getFather(x))
  asc2 <- as.character(getMother(x))
  testAsc1 <- !isUnknown(asc1)
  testAsc2 <- !isUnknown(asc2)
  ## individuals with at least one ascendant known
  set <- which(!(!testAsc1 & !testAsc2))

  ## --- Core ---

  for(i in set) {                # loop over set
    j <- 1:(i - 1)               # ret is a lower triangular matrix
    if(testAsc1[i]) tmp <-       0.5 * ret[asc1[i], j]
    if(testAsc2[i]) tmp <- tmp + 0.5 * ret[asc2[i], j]
    ret[i, j] <- tmp
  }

  ## --- End ---

  if(sort) ret <- ret[idOrig, idOrig]
  if(!names) attr(ret, which="dimnames") <- NULL
  ret
}

### }}}
### {{{ Inverse of gene flow matrix - Tinv
###------------------------------------------------------------------------

geneFlowTinv <- function(x, sort=TRUE, names=TRUE, ...)
{
  ret <- - gameteFlowM(x, sort=sort, names=names, ...)
  diag(ret) <- 1
  ret
}

### }}}
### {{{ Gamete flow matrix - M

###------------------------------------------------------------------------

gameteFlowM <- function(x, sort=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  ascendant <- getAscendantName(x)
  if(length(ascendant) > 2)
    stop("no method for pedigree with more than two ascendants")
  if(sort) idOrig <- as.character(getId(x))  # for sort-back

  ## Pedigree must be extended and sorted FIXME?
  x <- checkAttributes(x, extended=TRUE, sorted=TRUE)

  n <- nrow(x)
  ret <- matrix(0, n, n)         # n*n matrix
  rownames(ret) <- colnames(ret) <- getId(x)

  asc1 <- as.character(getFather(x))
  asc2 <- as.character(getMother(x))
  testAsc1 <- !isUnknown(asc1)
  testAsc2 <- !isUnknown(asc2)
  ## individuals with at least one ascendant known
  set <- which(!(!testAsc1 & !testAsc2))

  ## --- Core ---

  for(i in set) {                # loop over set
    if(testAsc1[i]) ret[i, asc1[i]] <- 0.5
    if(testAsc2[i]) ret[i, asc2[i]] <- 0.5
  }

  ## --- End ---

  if(sort) ret <- ret[idOrig, idOrig]
  if(!names) attr(ret, which="dimnames") <- NULL
  ret
}

### }}}
### {{{ Mendelian sampling covariance matrix - D

###------------------------------------------------------------------------

mendelianSamplingD <- function(x, matrix=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  ascendant <- getAscendantName(x)
  if(length(ascendant) > 2)
    stop("no method for pedigree with more than two ascendants")

  n <- nrow(x)
  ret <- vector(mode="numeric", length=n)    # n vector ~ diagonal matrix
  ret[] <- 1                                 # has maximally 1 (unknown parents)

  sub <- as.character(getId(x))
  asc1 <- as.character(getFather(x))
  asc2 <- as.character(getMother(x))
  testAsc1 <- !isUnknown(asc1)
  testAsc2 <- !isUnknown(asc2)

  ## --- Core ---

  inbF <- inbreeding(x=x)
  ## Known ascendant1
  ret[testAsc1] <- ret[testAsc1] - 0.25 * (1 + inbF[asc1[testAsc1]])
  ## Known ascendant2
  ret[testAsc2] <- ret[testAsc2] - 0.25 * (1 + inbF[asc2[testAsc2]])

  ## --- End ---

  if(matrix) {
    tmp <- matrix(0, nrow=n, ncol=n)
    diag(tmp) <- ret
    ret <- tmp
  }
  if(names & matrix) rownames(ret) <- colnames(ret) <- sub
  if(names & !matrix) names(ret) <- sub
  ret
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### TDT.R ends here

### runit.genRelMatrix.R
###------------------------------------------------------------------------
### What: Unit tests for genetic relationship methods
### $Id: runit.genRelMatrix.R 1174 2007-04-03 14:07:11Z ggorjan $
### Time-stamp: <2007-04-03 02:28:36 ggorjan>
###------------------------------------------------------------------------

### {{{ --- Test setup ---

if(FALSE) {
  library("RUnit")
  library("GeneticsPed")
}

### }}}
### {{{ --- Pedigrees ---

data(Mrode2.1)
Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                 ascendantSex=c("M", "F"), family="fam", sex="sex",
                 generation="gen", dtBirth="dtB")
n2.1 <- nrow(x2.1)

data(Mrode3.1)
x3.1 <- Pedigree(x=Mrode3.1, subject="calf", ascendant=c("sire", "dam"),
                 ascendantSex=c("Male", "Female"), sex="sex")
n3.1 <- nrow(x3.1)

### }}}
### {{{ --- Additive relationship matrix (A) ---

test.A <- function()
{
  ## Test with result on page 26 of Mrode (2005)
  test <- matrix(c(1,    0,     0.5,    0.5,    0.5,    0.25,
                   0,    1,     0.5,    0,      0.25,   0.625,
                   0.5,  0.5,   1,      0.25,   0.625,  0.5625,
                   0.5,  0,     0.25,   1,      0.625,  0.3125,
                   0.5,  0.25,  0.625,  0.625,  1.125,  0.6875,
                   0.25, 0.625, 0.5625, 0.3125, 0.6875, 1.125),
                 nrow=n2.1, ncol=n2.1)
  checkIdentical(relationshipAdditive(x2.1, names=FALSE), test)

  ## Output of solve(relationshipAdditive(x)) must be ~equal to
  ## inverseAdditive(x)

  x <- generatePedigree(nId=30, nGeneration=6) # highly inbreed pedigree
  test1 <- solve(relationshipAdditive(x))
  test2 <- inverseAdditive(x)
  checkEquals(test1, test2)
}


### }}}
### {{{ --- Inbreeding (F) ---

test.F <- function()
{
  ## Test with result on page 27 of Mrode (2005)
  test <- c(0, 0, 0, 0, 0.125, 0.125)
  checkIdentical(inbreeding(x2.1, names=FALSE), test)
  ## checkIdentical(inbreeding(x2.1, method="sargolzaei", names=FALSE), test)
  checkIdentical(inbreeding(x2.1, method="tabular", names=FALSE), test)
}

### }}}
### {{{ --- Gene and gamete flow matrix (T, Tinv, M) ---

#test.T <- function()
#{
#  ## Test with result on page 28 of Mrode (2005)
#  test <- matrix(c(1,    0,     0,    0,    0,   0,
#                   0,    1,     0,    0,    0,   0,
#                   0.5,  0.5,   1,    0,    0,   0,
#                   0.5,  0,     0,    1,    0,   0,
#                   0.5,  0.25,  0.5,  0.5,  1,   0,
#                   0.25, 0.625, 0.25, 0.25, 0.5, 1),
#                 nrow=n2.1, ncol=n2.1, byrow=TRUE)
#  checkIdentical(geneFlowT(x2.1, names=FALSE), test)
#}
#
#test.Tinv <- function()
#{
#  ## Test with result on page 28 of Mrode (2005)
#  test <- matrix(c(1,     0,    0,    0,    0,   0,
#                   0,     1,    0,    0,    0,   0,
#                   -0.5, -0.5,  1,    0,    0,   0,
#                   -0.5,  0,    0,    1,    0,   0,
#                   0,     0,   -0.5, -0.5,  1,   0,
#                   0,    -0.5,  0,    0,   -0.5, 1),
#                 nrow=n2.1, ncol=n2.1, byrow=TRUE)
#  checkIdentical(geneFlowTinv(x2.1, names=FALSE), test)
#}
#
#test.M <- function()
#{
#  ## Test with result on page 29 of Mrode (2005)
#  test <- matrix(c(0,   0,   0,   0,   0,   0,
#                   0,   0,   0,   0,   0,   0,
#                   0.5, 0.5, 0,   0,   0,   0,
#                   0.5, 0,   0,   0,   0,   0,
#                   0,   0,   0.5, 0.5, 0,   0,
#                   0,   0.5, 0,   0,   0.5, 0),
#                 nrow=n2.1, ncol=n2.1, byrow=TRUE)
#  checkIdentical(gameteFlowM(x2.1, names=FALSE), test)
#}
#
#### }}}
#### {{{ --- Mendelian sampling covariance matrix (D) ---
#
#test.D <- function()
#{
#  ## Test with result on page 28 of Mrode (2005)
#  test <- c(1, 1, 0.5, 0.75, 0.5, 0.46875)
#  test1 <- matrix(0, nrow=n2.1, ncol=n2.1)
#  diag(test1) <- test
#  checkIdentical(mendelianSamplingD(x2.1, matrix=FALSE, names=FALSE), test)
#  checkIdentical(mendelianSamplingD(x2.1, names=FALSE), test1)
#}

### }}}
### {{{ --- Model matrix (Z) ---

test.Z <- function()
{
  test <- matrix(c(0, 0, 0, 1, 0, 0, 0, 0,
                   0, 0, 0, 0, 1, 0, 0, 0,
                   0, 0, 0, 0, 0, 1, 0, 0,
                   0, 0, 0, 0, 0, 0, 1, 0,
                   0, 0, 0, 0, 0, 0, 0, 1), nrow=n3.1, byrow=TRUE)
  Z <- model.matrix(object=x3.1, y=x3.1$pwg, id=x3.1$calf, names=FALSE)
  checkIdentical(test, Z)
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### runit.genRelMatrix.R ends here

### model.matrix.R
###------------------------------------------------------------------------
### What: Model matrix for individuals with and without records
### $Id: model.matrix.R 1163 2007-04-03 13:58:58Z ggorjan $
### Time-stamp: <2007-04-01 03:40:28 ggorjan>
###------------------------------------------------------------------------

model.matrix.Pedigree <- function(object, y, id, left=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  if(is.matrix(y) && ncol(y) > 1) stop("no method for multivariate data")
  subject <- attr(object, ".subject")

  n <- length(id)
  ## Ensuring proper order in the pedigree, based on id
  rownames(object) <- object[[subject]]
  object <- object[id, ]
  ## Expanding the pedigree to get number of founders
  object <- extend(object)
  k <- nrow(object) - n

  ## --- Core ---

  ret <- model.matrix(~ id - 1, ...)
  if(left) {
    ret <- cbind(matrix(0, nrow=n, ncol=k), ret)
  } else {
    ret <- cbind(ret, matrix(0, nrow=n, ncol=k))
  }

  ## --- End ---

  if(names) colnames(ret) <- object[[subject]]
  if(!names) attr(ret, which="dimnames") <- NULL
  ret
}

###------------------------------------------------------------------------
### model.matrix.R ends here

### sort.Pedigree.R
###------------------------------------------------------------------------
### What: Sort Pedigree
### $Id: sort.pedigree.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-11-12 10:14:24 ggorjan>
###------------------------------------------------------------------------

sort.Pedigree <- function(x, decreasing=FALSE, na.last=TRUE, ...,
                          by="default")
{
  ## --- Setup ---

  dtBirth <- attr(x, ".dtBirth")
  generation <- attr(x, ".generation")

  if(by == "default") {                  ## Find way to sort pedigree
    if(!is.na(dtBirth)) {                  ## Is dtBirth available?
      if(sum(is.na(x[[dtBirth]])) == 0)    ## Do all have dtBirth?
        by <- "dtBirth"
    }
  }
  if(by == "default") {
    if(!is.na(generation)) {               ## Is generation available
      if(sum(is.na(x[[generation]])) == 0) ## Do all have generation?
        by <- "generation"
    }
  }
  if(by == "default") by <- "pedigree"     ## Just use pedigree information

  ## --- Sort on different information ---

  if(by == "pedigree") {
    warning("sorting by pedigree information is not yet implemented")
    return(x)
  }

  if(by == "generation") {
    if(!is.na(generation)) {
      args <- list()
      args$decreasing <- decreasing
      args$na.last <- na.last
      if(is.null(args$decreasing)) {
        args$decreasing <- ifelse(attr(x, ".generationOrder") == "increasing",
                             FALSE, TRUE)
      }
      attr(x, ".sorted") <- TRUE
      if ( decreasing )
      {
        subject <- attr(x, ".subject")
        ascendant <- attr(x, ".ascendant")
        na.value <- paste(as.character(attr(x, ".unknown")$.id))
        n.na <- length(na.value)
        n <- nrow(x)
      	ret <- .C(R_pedSort,
            ## 1 number of individuals
            as.integer(n),
            ## 2 individual ID
            as.character(x[[subject]]),
            ## 3 father ID
            as.character(x[[ascendant[1]]]),
            ## 4 mother ID
            as.character(x[[ascendant[2]]]),
            ## 5 matrix coefficients
            ## 7 character string indicating missing values
            as.character(na.value),
            ## 9 length of character string indicating missing values
            as.integer(n.na),
            PACKAGE="GeneticsPed")
        x[[subject]] <- ret[[2]]
        x[[ascendant[1]]] <- ret[[3]]
        x[[ascendant[2]]] <- ret[[4]]
      	return( x )
      }
      else
      {
        return(x[do.call(order, c(list(x[[generation]]), args)), ])
      }
#      return(x[do.call("order", c(list(x[[generation]]), args)), ])
    } else {
      stop("there is no data on 'generation' in pedigree")
    }
  }

  if(by == "dtBirth") {
    if(!is.na(dtBirth)) {
      attr(x, ".sorted") <- TRUE
      return(x[order(x[[dtBirth]], na.last=na.last, decreasing=decreasing), ])
    } else {
      stop("there is no data on 'dtBirth' in pedigree")
    }
  }
}

###------------------------------------------------------------------------
### sort.Pedigree.R ends here

### inverseAdditive.R
###------------------------------------------------------------------------
### What: Inverse of Additive Relationship Matrix
### $Id: inverseAdditive.R 1167 2007-04-03 14:02:23Z ggorjan $
### Time-stamp: <2007-04-03 16:01:34 ggorjan>
###------------------------------------------------------------------------

inverseAdditive <- function(x, sort=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  subject <- attr(x, ".subject")
  ascendant <- attr(x, ".ascendant")
  if(length(ascendant) > 2)
    stop("no method for pedigree with more than two ascendants")
  if(sort) idOrig <- as.character(x[[subject]])  # for sorting-back

  ## FIXME: all this is not needed! - check Dave's code
  ## Pedigree must be sorted, extended and unknown equal to NA
  ##x <- checkAttributes(x, sorted=TRUE, extended=TRUE, unknownNA=TRUE)
  ## I've commented out the above as my code does sort and extend, but does require
  ##  that unknowns be coded correctly.  This will likely save considerable time
  ##  for large pedigrees.
  x <- checkAttributes(x, sorted=FALSE, extended=FALSE, unknownNA=TRUE)

  ## Find unknown value (NA, "NA", 0, ...)
  ## paste is used due to possibility of having NA and as.character returns
  ## NA and not "NA" i.e. paste(NA) returns "NA"
  na.value <- paste(as.character(attr(x, ".unknown")$.id))

  ## --- Core ---

  n <- nrow(x)
  idx <- vector(mode="integer" , length=n)
  ret <- .C(R_inverseAdditive,
            ## 1 number of individuals
            as.integer(n),
            ## 2 individual ID
            as.character(x[[subject]]),
            ## 3 father ID
            as.character(x[[ascendant[1]]]),
            ## 4 mother ID
            as.character(x[[ascendant[2]]]),
            ## 5 matrix coefficients
            as.double(matrix(0, nrow=n, ncol=n)),
            ## 6 vector of sorted indexes
            idx,
            ## 7 character string indicating missing values
            as.character(na.value),
            ## 9 length of character string indicating missing values
            as.integer(length(na.value)),
            PACKAGE="GeneticsPed")[c(2, 5, 6)]
  ret[[2]] <- matrix(ret[[2]], nrow=n)
  idx <- order(ret[[3]])
  ret[[2]] <- ret[[2]][idx, idx]
  colnames(ret[[2]]) <- rownames(ret[[2]]) <- ret[[1]]

  ## --- End ---

  if(sort) ret <- ret[[2]][idOrig, idOrig]
  if(!names) attr(ret, which="dimnames") <- NULL
  ret
}

###------------------------------------------------------------------------
### inverseAdditive.R ends here

### family.R
###------------------------------------------------------------------------
### What: Find families (lines) in the pedigree
### $Id: family.R 1170 2007-04-03 14:04:37Z ggorjan $
### Time-stamp: <2007-04-03 00:30:24 ggorjan>
###------------------------------------------------------------------------

## FIXME: Any way to use original family names here i.e. we output integer
## code for families, but it might be the case that we already have some
## data and we can either confirm this or refute. Confirmation would be OK,
## but in case of refute we would need to paste all family names together.
##
## Example
## id dad mom fam
## 1  0   0   A
## 2  0   0   A
## 3  0   0   B
## 4  1   2   A
## 5  1   2   A
## 6  1   3   B
## 8  0   0   C
## 9  0   0   C
## 7  8   9   C
## Here it is clear that family C should stay family C and the same with
## A. What to do with individual 6? Should his family be A or B?

## x <- data.frame( id=c(1, 2, 3, 4, 5, 6, 8, 9, 7),
##                 dad=c(0, 0, 0, 1, 1, 1, 0, 0, 8),
##                 mom=c(0, 0, 0, 2, 2, 3, 0, 0, 9),
##                 fam=c("A", "A", "B", "A", "A", "B", "C", "C", "C"))
## x <- Pedigree(x=x, subject="id", ascendant=c("dad", "mom"), unknown=0)
## family(x)
## FIXME: It should definitely not say the same family for individual 3
## as 1 and 2 or should it? Perhaps we need to change the order of the
## algorithm
## 1 2 3 4 5 6 8 9 7
## 2 2 2 2 2 2 1 1 1

family <- function(x)
{
  ## --- Setup ---

  subject <- attr(x, ".subject")
  idInput <- as.character(x[[subject]]) ## for sort-back

  ## Pedigree must be sorted and extended
  x <- checkAttributes( x , sorted = TRUE , extended = TRUE )
  n <- nrow(x)
  f <- n:1                           ## at the start each id is its own family
  names(f) <- x[[subject]]
  nFounder <- sum(isFounder(x))

  ## --- Find families ---

  ## FIXME: test if geneFlowT would be faster
  A <- relationshipAdditive(x)
  for(i in n:(n - nFounder + 1)) {  ## Go from bottom up to founders
    ## FIXME: another problem here with founders. It is not necesarry that
    ## founders appear on top of the pedigree, they can also be somewhere
    ## in between if sorting is by date of birth or generation!
    test <- A[i, 1:(i - 1)] > 0     ## Find relatives and
    f[1:(i - 1)][test] <- f[i]      ##   put them in the same family
  }

  ## --- Renumber from 1:nFamily ---

  fTmp <- sort(unique(f))
  fTmp1 <- 1:length(fTmp)
  for(i in seq(along=fTmp)) {
    f[f %in% fTmp[i]] <- fTmp1[i]
  }

  ## --- End ---

  f[idInput]
}

"family<-" <- function(x, col=NULL, value)
{
  ## --- Setup ---

  famAttr <- attr(x, ".family")
  colTest <- is.null(col)

  if(is.na(famAttr) & colTest) attr(x, ".family") <- col <- "family"
  if(!is.na(famAttr) & colTest) col <- attr(x, ".family")
  if(!is.na(famAttr) & !colTest) { ## rename column with col
    colNamesT <- names(x)
    colNamesT[colNamesT == famAttr] <- col
    colnames(x) <- colNamesT
    attr(x, ".family") <- col
  }

  ## --- Apply ---

  x[[col]] <- value

  x
}

###------------------------------------------------------------------------
### family.R ends here

### runit.extend.R
###------------------------------------------------------------------------
### What: Unit tests for "unknown" methods
### $Id: runit.extend.R 1174 2007-04-03 14:07:11Z ggorjan $
### Time-stamp: <2007-04-03 14:46:30 ggorjan>
###------------------------------------------------------------------------

### {{{ --- Test setup ---

if(FALSE) {
  library("RUnit")
  library("GeneticsPed")
}

### }}}
### {{{ --- Pedigrees ---

data(Mrode2.1)
Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                 ascendantSex=c("M", "F"), family="fam", sex="sex",
                 generation="gen", dtBirth="dtB")
x2.1TestAgainst <- x2.1

data(Mrode3.1)
x3.1 <- Pedigree(x=Mrode3.1, subject="calf", ascendant=c("sire", "dam"),
                 ascendantSex=c("Male", "Female"), sex="sex")
x3.1TestAgainst <- x3.1

### }}}
### {{{ --- extend ---

test.extend <- function() {
  ## Removing founders and extending
  x2.1 <- x2.1[!isFounder(x2.1), ]
  x2.1Test <- extend(x2.1)

  ## Prepairing testAgainst object
  ## FIXME: family() does not work at the moment
  x2.1TestAgainst$fam <- NULL
  x2.1Test$fam <- NULL
  ## FIXME: there is no method for "getting" approx. date of birth
  x2.1TestAgainst[isFounder(x2.1TestAgainst), "dtB"] <- NA
  ## Extending does not care the order or individuals and factor levels
  for(i in seq(along=names(x2.1Test))) {
    if(is.factor(x2.1Test[[i]])) {
      x2.1Test[[i]] <- as.character(x2.1Test[[i]])
      x2.1TestAgainst[[i]] <- as.character(x2.1TestAgainst[[i]])
    }
  }
  x2.1TestAgainst <- x2.1TestAgainst[order(x2.1TestAgainst$sub), ]
  x2.1Test <- x2.1Test[order(x2.1Test$sub), ]
  attr(x2.1TestAgainst, ".extended") <- TRUE
  row.names(x2.1TestAgainst) <- NULL
  row.names(x2.1Test) <- NULL
  checkEquals(x2.1Test, x2.1TestAgainst)

  ## x3.1 test about extension of additional data
  x3.1Test <- extend(x3.1)$pwg
  x3.1TestAgainst <- c(NA, NA, NA, x3.1$pwg)
  checkEquals(x3.1Test, x3.1TestAgainst)

  ## x3.1 test about top
  x3.1Test <- extend(x3.1, top=FALSE)$pwg
  x3.1TestAgainst <- c(x3.1$pwg, NA, NA, NA)
  checkEquals(x3.1Test, x3.1TestAgainst)
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### runit.extend.R ends here

### removeIndividual.R
###------------------------------------------------------------------------
### What: Remove individual from Pedigree
### $Id: removeIndividual.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-09-30 01:11:07 ggorjan>
###------------------------------------------------------------------------

removeIndividual <- function(x, individual, remove="all")
{
  ## --- Check ---
  x <- checkAttributes(x)
  subject <- attr(x, ".subject")
  ascendant <- attr(x, ".ascendant")

  if(!any(c(subject, ascendant, "all") %in% remove))
    stop(sprintf("'remove' can only be: %s",
                 paste(dQuote(c(subject, ascendant, "all")), collapse=", ")))

  ## --- Core ---
  ## all equals to all id
  if(length(remove) == 1 && remove == "all") remove <- c(subject, ascendant)

  ## any individuals that are not in x?
  tmp <- individual %in% unlist(x[, remove])
  if(any(!tmp))
    warning(sprintf("no individual(s) %s in 'x'", paste(individual[!tmp], collapse=",")))

  ## remove them
  for(i in seq(along=remove)) {
    if(remove[i] == attr(x, ".subject")) { ## remove row if this is subject
      test <- which(x[[subject]] %in% individual)
      ## fix extend status if founders are removed
      if(any(isFounder(x[test, ]))) attr(x, ".extended") <- FALSE
      x <- x[-test, ]
    } else { ## set to unknown if this is ascendant
      x[x[[remove[i]]] %in% individual, remove[i]] <- attr(x, ".unknown")$.id
    }
  }

  ## fix levels for factors
  if(attr(x, ".colClass") == "factor")
    x[, remove] <- lapply(x[, remove], factor)

  x
}

###------------------------------------------------------------------------
### removeIndividual.R ends here

### inbreeding.R
###------------------------------------------------------------------------
### What: Inbreeding coefficient (F)
### $Id: inbreeding.R 1172 2007-04-03 14:05:59Z ggorjan $
### Time-stamp: <2007-03-31 19:42:29 ggorjan>
###------------------------------------------------------------------------

inbreeding <- function(x, method="meuwissen", sort=TRUE, names=TRUE, ...)
{
  ## --- Setup ---

  subject <- attr(x, ".subject")
  ascendant <- attr(x, ".ascendant")
  if(length(ascendant) > 2)
    stop("no method for pedigree with more than two ascendants")
  if(sort) idOrig <- as.character(x[[subject]]) # for sorting-back

  ## Pedigree must be sorted, extended and unknowns must be NA
  ## x <- checkAttributes(x=x, sorted=TRUE, extended=TRUE, unknownNA=TRUE)

  n <- nrow(x)
  ret <- vector(mode="numeric", length=n)
  ## paste is used due to possibility of having NA and as.character returns
  ## NA and not "NA" i.e. paste(NA) returns "NA"
  na.value <- paste(as.character(attr(x, ".unknown")$.id))

  METHODS <- c("meuwissen", "tabular")
  method <- METHODS[pmatch(method, METHODS)]
  if(is.na(method)) stop("invalid method")

  ## --- Kernel ---

  if(method == "tabular") {          # Tabular method i.e. F_i = A_ii - 1
    ret <- diag(relationshipAdditive(x, sort=sort, names=FALSE, ...)) - 1
  } else if(method == "meuwissen") { # Meuwissen and Luo method
    idx <- vector(mode="integer", length=n)
    ret <- .C(R_meuwissen,
              ## 1 number of individuals
              as.integer(n),
              ## 2 individual
              as.character(x[[subject]]),
              ## 3 father
              as.character(x[[ascendant[1]]]),
              ## 4 mother
              as.character(x[[ascendant[2]]]),
              ## 5 coefficients
              as.double(ret),
              ## 6 vector of sorted indexes
              idx,
              ## 7 character string indicating missing values
              as.character(na.value),
              ## 8 length of character string indicating missing values
              as.integer(length(na.value)),
              PACKAGE="GeneticsPed")[c(5, 6)]
    ret <- ret[[1]][order(ret[[2]])]
  }

  ## --- End ---

  names(ret) <- x[[subject]]
  if(sort) ret <- ret[idOrig]
  if(!names) names(ret) <- NULL
  ret
}

###------------------------------------------------------------------------
### inbreeding.R ends here

!     gpi.for
!-----------------------------------------------------------------------
!     What:  Genotype Probability Index (GPI) calculation
!     $Id: gpi.f 1153 2007-03-02 17:12:03Z ggorjan $
!     Time-stamp: <2007-09-12 23:37:38 ggorjan>
!     Subroutines: gpi, gpiCore
!-----------------------------------------------------------------------
!
!     Subroutine: gpi
!
!     Genotype Probability Index (GPI) for a set of individuals -
!     wrapper around subroutine gpiCore (look bellow)
!
!     Input:
!
!      nobs integer(1), number of individuals/records
!
!      n    integer(1), number of alleles
!
!      gp   double precision(nobs, k), individual genotype probabilities
!
!      hwp  double precision(nobs, k), Hardy-Weinberg genotype probabilities
!
!     Return:
!
!      ret  double precision(nobs), individual genotype probability indices
!
!     gp and hwp expect values for all possible genotypes, except for
!     the homozygote of the last allele as shown bellow. Note that
!     dimensions of hwp must be the same to dimensions of gp to allow
!     for possibly different values of hwp per individual. This is
!     handy, but hwp needs to properly prepaired - i.e. recycled - done
!     at R level.

      subroutine gpi(nobs, n, gp, hwp, ret)
        implicit none
        integer nobs, n, k, i, j
        double precision gp(nobs, n*(n+1)/2-1), hwp(nobs, n*(n+1)/2-1)
        double precision ret(nobs), gp2(n*(n+1)/2-1), hwp2(n*(n+1)/2-1)

        k=n*(n+1)/2-1

!       Loop over individuals i.e. calculate GPI for each individual
        do i = 1, nobs
!         Get gp2 and hwp2 for each individual
          do j = 1, k
            gp2(j) = gp(i, j)
            hwp2(j) = hwp(i, j)
          end do
          call gpiCore(n, k, gp2, hwp2, ret(i))
        end do
        return
      end subroutine

!-----------------------------------------------------------------------
!
!     Subroutine: gpiCore
!
!     Genotype Probability Index (GPI) for an individual
!
!     Method is described in Percy, A. and Kinghorn, B.P. 2005.
!     A genotype probability index for multiple alleles and haplotypes.
!     Journal of Animal Breeding and Genetics, 122: 387-392
!     http://dx.doi.org/10.1111/j.1439-0388.2005.00553.x
!
!     Gregor Gorjanc modified code by Percy and Kinghorn to FORTRAN 77
!     (for maximal portability with R) and added documentation.
!
!     Input:
!
!      n   integer(1), number of alleles
!
!      k   integer(1), number of dimensions for 'multiangles' = n*(n+1)/2-1
!
!      gp  double precison(k), individual's genotype probabilities
!
!      hwp double precison(k), Hardy-Weinberg genotype probabilities
!
!     Return:
!
!      ret double precision(1), individual's genotype probability index
!
!     gp and hwp expect values for all possible genotypes, except for the
!     homozygote of the last allele e.g. for
!
!     2 alleles: 1 and 2
!     11 12
!     --> k=2
!
!     3 alleles: 1, 2, and 3
!     11 12 13
!        22 23
!     --> k=5
!
!     4 alleles: 1, 2, 3, and 4
!     11 12 13 14
!        22 23 24
!           33 34
!     --> k=9
!
!     5 alleles: 1, 2, 3, 4, and 5
!     11 12 13 14 15
!        22 23 24 25
!           33 34 35
!              44 45
!     --> k=14

      subroutine gpiCore(n, k, gp, hwp, ret)
        implicit none
        integer n, ndim, i, j, k
        double precision a(k, k), b(k, 1), gp(k, 1), hwp(k, 1)
        double precision tmp(k, 1), c, qa, qb, qc, t, ret

        ndim = n*(n+1)/2-1
        do i = 1, ndim
          do j = 1, ndim
            a(i, j) = 0
          end do
        end do
        a(1, 1) = 1
        do i = 2, ndim
          a(i, i) = 0
          do j = 1, i-1
            a(i, i) = a(i, i) + ((a(j, j) / (float(j) + 1.))**2)
          end do
          a(i, i) = sqrt(1 - a(i, i))
        end do
        do i = 1, ndim
          b(i, 1) = (1. / (float(i) + 1.)) * a(i, i)
          do j = i+1, ndim
            a(i, j) = (1. / (float(i) + 1.)) * a(i, i)
          end do
        end do
        c = (float(ndim) + 1.) / (float(ndim) * a(ndim, ndim))

!        hwp = c * (matmul(a, hwp) - b)
        call ggmatmul(a, hwp, ndim, ndim, ndim, 1, tmp)
        do i = 1, ndim
          hwp(i, 1) = c * (tmp(i, 1) - b(i, 1))
        enddo

!        gp = c * (matmul(a, gp) - b)
        call ggmatmul(a, gp, ndim, ndim, ndim, 1, tmp)
        do i = 1, ndim
          gp(i, 1) = c * (tmp(i, 1) - b(i, 1))
        enddo

        qa = 0.
        qb = 0.
        qc = 0.
        do i = 1, ndim
          qa = qa +  (gp(i, 1) - hwp(i, 1))**2
          qb = qb + 2*hwp(i, 1) * (gp(i, 1) - hwp(i, 1))
          qc = qc +   hwp(i, 1) * hwp(i, 1)
        end do
        qc = qc-1
        if(qa <. 00000001) then
          ret = 0.
        else
          t = (-qb + sqrt(qb*qb - 4*qa*qc) ) / (2*qa)
          ret = 100 / t
        end if
        return
      end subroutine

!-----------------------------------------------------------------------
!     gpi.for ends here

### check.Pedigree.R
###------------------------------------------------------------------------
### What: Check Pedigree for common errors
### $Id: check.pedigree.R 1189 2007-04-06 10:58:28Z ggorjan $
### Time-stamp: <2007-09-07 09:30:17 ggorjan>
###------------------------------------------------------------------------

check <- function(x, ...)
  UseMethod("check")

check.Pedigree <- function(x, ...)
{
  checkId(x)
  if(!is.na(getSexName(x))) checkSex(x)
  ##  if(!is.na(getDtBirthName(x))) checkDtBirth(x)
}

checkAttributes <- function(x, coded=FALSE, extended=FALSE, sorted=FALSE,
                            unknownNA=FALSE, ...)
{
  ## --- Class ---

  if(!is.Pedigree(x)) {
    if(options()$verbose)
      cat(sprintf("Coercing to %s class\n", dQuote("Pedigree")))
    x <- Pedigree(x)
  }

  ## --- Renumber ---

  if(!getCoded(x) & coded) {
    if(options()$verbose) cat("Coding - (not yet implemented)\n")
    ## x <- ???(x)
  }

  ## --- Extend ---

  if(!getExtended(x) & extended) {
    if(options()$verbose) cat("Extending\n")
    x <- extend(x, ...)
  }

  ## --- Sort ---

  if(!getSorted(x) & sorted) {
    if(options()$verbose) cat("Sorting\n")
    x <- sort(x, ...)
  }

  ## --- Unknown ---

  if(any(!is.na(getUnknown(x)$.id)) & unknownNA) {
    if(options()$verbose) cat("Unknown to NA\n")
    stop("no unknown handling at the moment")
    ## FIXME: x <- unknownToNA.Pedigree(x)
  }
  x
}

checkId <- function(x)
{
  error <- FALSE
  ret <- list()

  idClass(x)

  ret$idIsNA <- idIsNA(x)
  if(is.list(ret$idIsNA)) error <- TRUE

  ret$idNotUnique <- idNotUnique(x)
  if(is.list(ret$idNotUnique)) error <- TRUE

  ret$idEqualAscendant <- idEqualAscendant(x)
  if(is.list(ret$idEqualAscendant)) error <- TRUE

  ret$ascendantEqualAscendant <- ascendantEqualAscendant(x)
  if(is.list(ret$ascendantEqualAscendant)) error <- TRUE

  ret$ascendantInAscendant <- ascendantInAscendant(x)
  if(is.list(ret$ascendantInAscendant)) error <- TRUE

  ret$unusedLevels <- unusedLevels(x)
  if(is.list(ret$unusedLevels)) error <- TRUE

  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

idClass <- function(x)
{
  col <- c(getIdName(x), getAscendantName(x))
  tmp <- lapply(x[, col], class)
  if(any(tmp != class(getId(x))))
    stop(sprintf("columns %s must have the same class",
                 paste(sQuote(col), collapse=", ")))
}

idIsNA <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Id can not be NA ---

  tmp <- is.na(getId(x))
  if(any(tmp)) {
    error <- TRUE
    ret$idIsNA <- list()
    ret$idIsNA$message <- sprintf("%s id can not be NA",
                                  sQuote(getIdName(x)))
    ret$idIsNA$rowIndex <- which(tmp)
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

idNotUnique <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Id must be unique ---

  if(nrow(x) != length(unique(getId(x)))) { # test is cheap
    tmp <- table(getId(x))
    tmp <- tmp[tmp > 1]
    tmp <- getId(x) %in% names(tmp)
    error <- TRUE
    ret$idNotUnique <- list()
    ret$idNotUnique$message <- sprintf("%s must be unique",
                                       sQuote(getIdName(x)))
    ret$idNotUnique$rowIndex <- which(tmp)
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

idEqualAscendant <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Id can not be equal to ascendant ---

  col <- getAscendantName(x)
  for(i in seq(along=col)) {
    if(getColClass(x) == "factor") {
      tmp <- as.character(getIdName(x)) == as.character(x[[col[i]]])
    } else {
      tmp <- getIdName(x) == x[[col[i]]]
    }
    tmp[is.na(tmp)] <- FALSE # NA come in if id is NA - I get this
                             # one above or if ascendant is NA, which is OK
    if(any(tmp)) {
      error <- TRUE
      retTmp <- vector("list", 1)
      retName <- paste(getIdName(x), "Equals", col[i], sep="")
      names(retTmp) <- retName
      ret <- c(ret, retTmp)
      ret[[retName]]$message <- sprintf("%s id can not be equal to id of %s",
                                        sQuote(getIdName(x)),
                                        sQuote(col[i]))
      ret[[retName]]$rowIndex <- which(tmp)
    }
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

ascendantEqualAscendant <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Ascendant can not be equal to ascendant ---
  col <- getAscendantName(x)
  for(i in seq(along=col)) {
    for(j in seq(along=col)) {
      if(j > i) {
        if(getColClass(x) == "factor") {
          tmp <- as.character(x[[col[i]]]) == as.character(x[[col[j]]])
        } else {
          tmp <- x[[col[i]]] == x[[col[j]]]
        }
        tmp[is.na(tmp)] <- FALSE # NA come if ascendants are unknown, which
                                 # is OK
        if(any(tmp)) {
          error <- TRUE
          retTmp <- vector("list", 1)
          retName <- paste(col[i], "Equals", col[j], sep="")
          names(retTmp) <- retName
          ret <- c(ret, retTmp)
          ret[[retName]]$message <-
            sprintf("%s id can not be equal to id of %s",
                    sQuote(col[i]), sQuote(col[j]))
          ret[[retName]]$rowIndex <- which(tmp)
        }
      }
    }
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

ascendantInAscendant <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Ascendant can not be in ascendant of a different sex ---
  col <- getAscendantName(x)
  colSex <- getAscendantSex(x)

  ## Put ascendants of equal sex together
  sex <- unique(colSex)
  tmp <- vector(mode="list", length=length(sex))
  names(tmp) <- sex
  for(i in seq(along=sex)) {
    if(getColClass(x) == "factor") {
      map <- mapLevels(x=x[, col[colSex == sex[i]]], combine=TRUE, codes=FALSE)
      mapLevels(x[, col[colSex == sex[i]]]) <- map
    }
    for(j in seq(along=col[colSex == sex[i]])) {
      tmp[[sex[i]]] <- c(tmp[[sex[i]]], x[, col[colSex == sex[i]][j]])
    }
    if(getColClass(x) == "factor") {
      tmp[[sex[i]]] <- factor(tmp[[sex[i]]])
      mapLevels(tmp[[sex[i]]]) <- map
    }
  }

  ## Check
  for(i in seq(along=sex)) {
    for(j in seq(along=sex)) {
      if(j > i) {
        if(getColClass(x) == "factor") {
          tmp1 <- as.character(tmp[[i]]) %in% as.character(tmp[[j]]) & !is.na(tmp[[i]])
        } else {
          tmp1 <- tmp[[i]] %in% tmp[[j]] & !is.na(tmp[[i]])
        }
        if(any(tmp1)) {
          error <- TRUE
          retTmp <- vector("list", 1)
          retName <- paste(paste(col[colSex == sex[i]], collapse="|"),
                           "In",
                           paste(col[colSex == sex[j]], collapse="|"), sep="")
          names(retTmp) <- retName
          ret <- c(ret, retTmp)
          ret[[retName]]$message <- sprintf("%s id can not be in id of %s",
                                            sQuote(paste(col[colSex == sex[i]], collapse="|")),
                                            sQuote(paste(col[colSex == sex[j]], collapse="|")))
          colSexN <- length(col[colSex == sex[i]])
          dim(tmp1) <- c(nrow(x), colSexN)
          if(colSexN > 1) {
            tmp1 <- rowSums(tmp1)
            tmp1 <- ifelse(tmp1 == 0, FALSE, TRUE)
          }
          ret[[retName]]$rowIndex <- which(tmp1)
        }
      }
    }
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

unusedLevels <- function(x)
{
  error <- FALSE
  ret <- list()

  ## --- Unused levels ---
  col <- getAscendantName(x)
  if(getColClass(x) == "factor") {
    col <- c(getIdName(x), getAscendantName(x))
    for(i in seq(along=col)) {
      lev1 <- levels(factor(x[[col[i]]]))
      tmp <- length(lev1)
      lev2 <- levels(x[[col[i]]])
      tmp1 <- length(lev2)
      if(tmp1 > tmp) {
        error <- TRUE
        retTmp <- vector("list", 1)
        retName <- paste("unusedLevelsIn", col[i], sep="")
        names(retTmp) <- retName
        ret <- c(ret, retTmp)
        ret[[retName]]$message <- sprintf("unused levels in %s", sQuote(col[i]))
        ret[[retName]]$levels <- lev2[!(lev2 %in% lev1)]
      }
    }
  }
  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

checkSex <- function(x)
{
  ## --- Setup ---

  error <- FALSE
  ret <- list()

  ascendant <- getAscendantName(x)
  ascendantSex <- getAscendantSex(x)
  sexV <- getSex(x)

  ## --- Core ---

  for(i in seq(along=ascendant)) {
    ## Test sex in individuals that appear as ascendants and that have known sex
    test <- sexV[getId(x) %in% getAscendant(x)[[i]] &
                 !(sexV %in% getUnknown(x)$.sex)] != ascendantSex[i]
    if(any(test)) {
      ## Test to get an individual with positive upper test
      test <- which(getId(x) %in%
                    getAscendant(x)[[i]] &
                    !(sexV %in% getUnknown(x)$.sex) &
                    !(sexV %in% ascendantSex[i]))
      error <- TRUE
      retTmp <- vector("list", 1)
      retName <- paste("wrongSexFor", ascendant[i], sep="")
      names(retTmp) <- retName
      ret <- c(ret, retTmp)
      ret[[retName]]$message <- sprintf("Should be %s", ascendantSex[i])
      ret[[retName]]$rowIndex <- test
    }
  }

  ## --- End ---

  if(error) {
    return(ret)
  } else {
    return(0)
  }
}

## checkDtBirth <- function(x)
## {
## }

###------------------------------------------------------------------------
### check.Pedigree.R ends here

### gpi.R
###------------------------------------------------------------------------
### What: Genotype probability index
### $Id: gpi.R 1155 2007-03-02 22:52:41Z ggorjan $
### Time-stamp: <2007-09-20 13:43:28 ggorjan>
###------------------------------------------------------------------------

### {{{ gpi

gpi <- function(gp, hwp)
{
  ## --- Tests ---

  if(!is.numeric(gp) || !is.numeric(hwp))
    stop("'gp' and 'hwp' must be numeric vector or matrix")
  if(any(gp < 0 | gp > 1) || any(hwp < 0 | hwp > 1))
    stop("probabilities should lie on interval 0, 1")
  if(any(is.na(gp)) || any(is.na(hwp)))
    stop("NA values are not allowed in 'gp' and 'hwp'")

  ## --- Setup ---

  msg <- "'gp' and 'hwp' must be of the same dimension"

  if(is.matrix(gp)) {
    k <- ncol(gp)
    nId <- nrow(gp)
    if(!is.matrix(hwp)) { # recycle hwp
      hwp <- matrix(hwp, nrow=nId, ncol=k, byrow=TRUE)
    } else {              # recyle should work only for vectors
      if(!isTRUE(all.equal(dim(gp), dim(hwp)))) stop(msg)
    }
  } else {
    if(is.matrix(hwp)) stop(msg)
    k <- length(gp)
    nId <- 1
    if(k != length(hwp)) stop(msg)
  }

  ## Number of dimensions (k) and alleles (n)
  ## k = n*(n + 1)/2 - 1
  ## 2(k + 1) = n^2 + n
  ## n^2 + n - 2k - 2 = 0 --> quadratic eq.
  ## n = (-b + sqrt(b^2 - 4ac)) / 2a
  ##   = (-1 + sqrt(1 - 4(-2k - 2))) / 2
  ##   = (-1 + sqrt(1 + 8k + 8)) / 2

  n <- (-1 + sqrt(1 + 8*k + 8)) / 2
  if(n %% 1 != 0) {
    msg <- c("nonconformant dimensions of 'gp':\n",
             sprintf("no. dimensions (k)= %s\n", k),
             sprintf("no. alleles (n) = %s\n", n),
             "k = n*(n + 1))/2 - 1?")
    stop(msg)
  }

  ## --- Call ---

  ret <- vector(mode="numeric", length=nId)
  ret <- .Fortran(R_gpi,
                  ## Number of individuals
                  nobs=as.integer(nId),
                  ## Number of alleles
                  n=as.integer(n),
                  ## Individual's genotype probabilities
                  gp=as.double(gp),
                  ## Hardy-Weinberg genotype probabilities
                  hwp=as.double(hwp),
                  ret=ret, PACKAGE="GeneticsPed")[["ret"]]

  ## --- Return ---

  ret
}

### }}}
### {{{ gpLong2Wide

gpLong2Wide <- function(x, id, genotype, prob, trim=TRUE)
{
  ## --- Check inputs ---

  if(!is.data.frame(x)) stop("'x' must be a data.frame")
  if(!all(sapply(list(id, genotype, prob), is.character)))
    stop("'id', 'genotype', and 'prob' must be character")
  if(!all(c(id, genotype, prob) %in% names(x)))
    stop("'id', 'genotype', and 'prob' must be column names of 'x'")
  if(!(is.genotype(x[, genotype])))
    stop("'x' must be of a genotype class")

  ## --- Setup ---

  idVal <- unique(x[, id])
  nId <- length(idVal)
  gen <- expectedGenotypes(alleles=allele.names(x[, genotype]))
  nGen <- length(gen)
  gp <- matrix(data=0, nrow=nId, ncol=nGen)
  colnames(gp) <- gen
  rownames(gp) <- idVal

  ## --- Fill the matrix ---

  for(i in seq(along=gen)) {
    test <- x[, genotype] == gen[i]
    idVal <- as.character(x[test, id])
    gp[idVal, gen[i]] <- x[test, prob]
  }

  ## --- Return ---

  if(trim) {
    gp[, 1:(ncol(gp) - 1)]
  } else {
    gp
  }
}

### }}}
### {{{ hwp

hwp <- function(x, trim=TRUE)
{
  ## --- Check inputs ---

  if(!(is.genotype(x)))
    stop("'x' must be of a genotype class")

  ## --- Calculate HWE probabilities ---

  ## Pr(AA) = Pr(A) * Pr(A)
  ## Pr(AB) = 2 * Pr(A) * Pr(B)
  ## ...

  tmp <- summary(x)$allele.freq
  tmp <- tmp[!is.na(tmp[, 2]), 2]
  hwp <- outer(X=tmp, Y=tmp, FUN="*")

  ## Keep only lower triangle with Pr(AA), Pr(AB), and Pr(BB);
  ## i.e. skip Pr(BA)
  lowerTriangle(hwp) <- 2 * lowerTriangle(hwp)
  hwp <- hwp[lower.tri(hwp, diag=TRUE)]

  ## --- Return ---

  if(trim) {
    hwp[1:(length(hwp) - 1)]
  } else {
    hwp
  }
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### gpi.R ends here

### runit.gpi.R
###------------------------------------------------------------------------
### What: Unit tests for gpi() method
### $Id: runit.gpi.R 1153 2007-03-02 17:12:03Z ggorjan $
### Time-stamp: <2007-09-13 03:34:20 ggorjan>
###------------------------------------------------------------------------

### {{{ --- Test setup ---

if(FALSE) {
  library("RUnit")
  library("GeneticsPed")
}

### }}}
### {{{ --- gpi ---

test.gpi <- function()
{
  ## --- Test examples - check man page for details ---

  ## Example 1
  gp <- c(.1, .5)
  hwp <- c(.5625, .3750)
  ret <- 51.8
  checkEquals(round(gpi(gp=gp, hwp=hwp), digits=1), ret)

  ## Example 1 extended
  (gp <- matrix(c(.1, .5, .2, .5), nrow=2, ncol=2, byrow=TRUE))
  ret <- c(ret, 40.5)
  checkEquals(round(gpi(gp=gp, hwp=hwp), digits=1), ret)

  ## Example 2
  gp <- c(.1, .5, .0, .4, .0)
  hwp <- c(.5625, .3750, .0, .0625, .0)
  ret <- 51.8
  checkEquals(round(gpi(gp=gp, hwp=hwp), digits=1), ret)

  ## Example 3

  (hwp <- rep(.2, times=5) %*% t(rep(.2, times=5)))
  hwp <- c(hwp[upper.tri(hwp, diag=TRUE)])
  (hwp <- hwp[1:(length(hwp) - 1)])
  gp <- hwp / 2
  gp[2] <- gp[2] + .5
  gp
  ret <- 50
  checkEquals(gpi(gp=gp, hwp=hwp), ret)

  ## --- Error checking ---

  ## probabilities should lie on interval 0, 1
  checkException(gpi(gp=-1, hwp=0.5),silent = TRUE)
  checkException(gpi(gp=0.5, hwp=5),silent = TRUE)

  ## 'gp' and 'hwp' must be numeric vectors or matrices
  checkException(gpi(gp="0.5", hwp=0.2),silent = TRUE)
  checkException(gpi(gp=0.5, hwp=list(0.2)),silent = TRUE)
  checkException(gpi(gp=matrix("0.5"), hwp=0.2),silent = TRUE)

  ## 'gp' and 'hwp' must be of the same dimension
  gp <- matrix(c(.1, .5, .6, .2), nrow=2, ncol=2, byrow=TRUE)
  checkException(gpi(gp=gp, hwp=gp[, 1, drop=FALSE]),silent = TRUE)
  ## if gp and hwp are matrices, they should be of the same dimension

  checkException(gpi(gp=c(.1, .5), hwp=gp[, 1, drop=FALSE]),silent = TRUE)
  ## if gp is vector, then hwp should also be a vector

  checkException(gpi(gp=c(.1, .5), hwp=c(.1)),silent = TRUE)
  ## gp and hwp must have the same length

  checkException(gpi(gp=c(.1, .5, .2, .0), hwp=c(.1, .6, .1, .1)),silent = TRUE)
  ## wrong number of genotype probabilities
}

### }}}
### {{{ --- gpLong2Wide ---

test.gpLong2Wide <- function()
{
  tmp <- data.frame(ind=c("A", "A", "A", "B", "B"),
                    gen=c("A/A", "A/B", "B/B", "A/A", "A/B"),
                    pro=c(0.5, 0.25, 0.25, 0.75, 0.25))

  checkException(gpLong2Wide(x=1),silent = TRUE)
  ## 'x' must be a data.frame
  checkException(gpLong2Wide(x=tmp, id=2, genotype="gen", prob="pro"),silent = TRUE)
  ## 'id', 'genotype', and 'prob' must be character
  checkException(gpLong2Wide(x=tmp, id="id", genotype="gen", prob="pro"),silent = TRUE)
  ## 'id', 'genotype', and 'prob' must be column names of 'x'
  checkException(gpLong2Wide(x=tmp, id="ind", genotype="gen", prob="pro"),silent = TRUE)
  ## 'x' must be of a genotype class

  if(require(genetics)) {
    tmp$gen <- as.genotype(tmp$gen)
    tmp2 <- gpLong2Wide(x=tmp, id="ind", genotype="gen", prob="pro")
    checkEquals(as.vector(tmp2), c(0.5, 0.75, 0.25, 0.25))
    tmp2 <- gpLong2Wide(x=tmp, id="ind", genotype="gen", prob="pro", trim=FALSE)
    checkEquals(as.vector(tmp2), c(0.5, 0.75, 0.25, 0.25, 0.25, 0))
  }

}

### }}}
### {{{ --- hwp ---

test.hwp <- function()
{
  checkException(hwp(x="A/A"))
  ## 'x' must be of a genotype class

  if(require(genetics)) {
    gen <- genotype(c("A/A", "A/B"))
    ## Pr(A)  = 3/4
    ## Pr(B)  = 1/4
    ## Pr(AA) = (3/4)^2           = 0.5625
    ## Pr(AA) = 2 * (3/4) * (1/4) = 0.3750
    ## Pr(BB) = (1/4)^2           = 0.0625
    ret <- c(0.5625, 0.3750, 0.0625)
    checkEquals(hwp(x=gen), ret[1:2])
    checkEquals(hwp(x=gen, trim=FALSE), ret)
  }
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### runit.gpi.R ends here

### Pedigree.R
###------------------------------------------------------------------------
### What: Pedigree class and methods
### $Id: pedigree.R 1165 2007-04-03 14:00:07Z ggorjan $
### Time-stamp: <2007-09-20 13:18:57 ggorjan>
###------------------------------------------------------------------------

### {{{ Pedigree

## setMethod(f="PedigreeS4", signature="data.frame",
##           def=function(x, subject="id", ascendant=c("father", "mother"),
##                        ascendantSex=c(1, 2), ascendantLevel=c(1, 1),
##                        unknown=NULL, generation=NULL, generationOrder="increasing",
##                        family=NULL, sex=NULL, sexName=c("male", "female"),
##                        dtBirth=NULL, other=NULL, gene=NULL, ...) {
##            x
##          })

## setMethod(f="PedigreeS4", signature="matrix",
##          def=function(x, ...) {
##            ## TODO
##            x
##          })

### }}}
### {{{ S3

###------------------------------------------------------------------------

Pedigree <- function(x, subject="id", ascendant=c("father", "mother"),
                     ascendantSex=c(1, 2), ascendantLevel=c(1, 1),
                     unknown=NA, sex=NA, dtBirth=NA, generation=NA,
                     family=NA, generationOrder="increasing", check=TRUE,
                     sort=FALSE, extend=FALSE, drop=TRUE, codes=FALSE) {

  ## --- Attributes ---

  class(x) <- c("Pedigree", "data.frame")

  ## FIXME: sex, dtBirth, generation, family, default to NULL and then
  ## if(is.null) NA

  attr(x, ".subject") <- subject
  attr(x, ".ascendant") <- ascendant
  attr(x, ".family") <- family
  attr(x, ".ascendantSex") <- ascendantSex
  attr(x, ".ascendantLevel") <- as.integer(ascendantLevel)
  attr(x, ".sex") <- sex
  attr(x, ".dtBirth") <- dtBirth
  attr(x, ".generation") <- generation
  attr(x, ".generationOrder") <- generationOrder
  attr(x, ".colClass") <- class(x[[subject]])[1]
  attr(x, ".checked") <- FALSE
  attr(x, ".sorted") <- FALSE
  attr(x, ".extended") <- FALSE
  attr(x, ".coded") <- FALSE
  attr(x, ".unknown") <- list(.id=NA, .family=NA, .sex=NA, .dtBirth=NA,
                              .generation=NA)

  ## --- Actions ---

  for(i in c(subject, ascendant, sex, dtBirth, generation)) {
    if(!is.na(i)) {
      if(is.null(x[[i]])) stop(sprintf("column %s does not exist", sQuote(i)))
    }
  }

  if(!(generationOrder %in% c("increasing", "decreasing"))) {
    stop(sprintf("'generationOrder' must %s or %s",
                 dQuote("increasing"), dQuote("decreasing")))
  }

  if(length(ascendant) != length(ascendantSex) |
     length(ascendant) != length(ascendantLevel) |
     length(ascendantSex) != length(ascendantLevel)) {
    stop("'ascendant', 'ascendantSex' and 'ascendantLevel' must have the same length")
  }

  idClass(x)
  ## all id must have the same class: not needed when check
  ## action will be working FIXME

  if(any(!is.na(unlist(unknown)))) {
    ## FIXME - remove this when you will handle unknown stuff
    ##    x <- unknownToNA.Pedigree(x=x, unknown=unknown)
    for(i in ascendant) x[x[, i] %in% unknown, i] <- NA
  }

  if(!is.na(sex)) {
    if(!all(attr(x, ".ascendantSex") %in% x[[attr(x, ".sex")]]))
      stop("values of 'ascendantSex' must accord with values of 'sex' column")
  }

  ##  if(check) # Check
  ##    check(x)

  if(sort) # Sort
    x <- sort.Pedigree(x)

  if(extend) # Extend
    x <- extend(x)

  if(attr(x, ".colClass") == "factor" & drop) # drop unused levels for factors
    x <- dropLevels(x)

  if(codes) # Code Pedigree
    stop("not available")
    ## x <- as.integer.Pedigree(x)

  ## --- Return ---
  x
}

## --- print ---

if(FALSE) {
  print.Pedigree <- function(x, ...)
    summary(x)
}

### }}}
### {{{ is., as.

## --- is. ---

is.Pedigree <- function(x) inherits(x, "Pedigree")

## --- as. ---

as.Pedigree <- function (x, ...) UseMethod("as.Pedigree")

as.Pedigree.Pedigree <- function(x, ...) x

as.Pedigree.data.frame <- function (x, ...) Pedigree(x, ...)

as.Pedigree.matrix <- function (x, ...)
{
  if(is.null(colnames(x)))
    stop("matrix 'x' needs column names to proceed")
  Pedigree(as.data.frame(x), ...)
}

if(FALSE) {

as.integer.Pedigree <- function(x, sort=FALSE, mapCha=FALSE, mapInt=FALSE, ...)
{
  col <- NULL
  ## FIXME: what to do with other columns i.e. factors, sex, anything else?
  ## FIXME: get 1:n with sort?
  if(sort) x <- sort(x)
  subject <- attr(x, ".subject")
  if(is.null(col)) col <- c(subject, attr(x, ".ascendant"))
  ## FIXME: combine=TRUE will be OK only for id columns!
  mapLCha <- mapLevels(x[, col], codes=FALSE, combine=TRUE)
  ## Applying the same map so that integer codes will be consistent
  mapLevels(x[, col]) <- mapLCha
  mapLInt <- mapLevels(x[[subject]])
  x[, col] <- lapply(x[, col], as.integer)
  attr(x, ".colClass") <- "integer"
  if(mapCha | mapInt) {
    ret <- list()
    ret$pedigree <- x
    if(mapCha) ret$mapCha <- mapLCha
    if(mapInt) ret$mapInt <- mapLInt
    ret
  } else {
    x
  }
}

as.factor.Pedigree <- function(x, map, ...)
{
  col <- NULL
  ## FIXME: what to do with other columns i.e. factors, sex, anything else?
  if(is.null(col)) col <- c(attr(x, ".subject"), attr(x, ".ascendant"))
  if(!missing(map)) {
    mapLevels(x[, col]) <- map
  } else {
    x[, col] <- lapply(x[, col], as.factor)
  }
  attr(x, ".colClass") <- "factor"
  x
}

as.character.Pedigree <- function(x, ...)
{
  col <- NULL
  ## FIXME: what to do with other columns i.e. factors, sex, anything else?
  if(is.null(col)) col <- c(attr(x, ".subject"), attr(x, ".ascendant"))
  x[, col] <- lapply(x[, col], as.character)
  attr(x, ".colClass") <- "character"
  x
}

}

### }}}
### {{{ [, [[

if(FALSE) {

## not easy as it is jumping from .data.frame to .Pedigree. Probably better
## to go with lists in general.

"[.Pedigree" <- function(x, i, j, drop=TRUE)
{
  ## --- Setup ---

  attrX <- attributes(x)                        ## save attributes
  classX <- class(x)
  class(x) <- classX[!(classX %in% "Pedigree")] ## remove Pedigree class

  nCol <- ncol(x)

  args <- vector(mode="list", length=3)
  names(args) <- c("i", "j", "drop")
  if(missing(drop)) args$drop <- NA else args$drop <- drop

  iMiss <- missing(i)
  jMiss <- missing(j)
  if(jMiss) args$j <- 1:nCol    else args$j <- j
  if(iMiss) args$i <- 1:nrow(x) else args$i <- i
  if(jMiss & iMiss) return(x[, , drop=drop])

  cat("Subsetting\n")

  ## --- Test if subseting changes extended status ---

  if(!iMiss) {
    n <- nrow(x[i, ])
    nAll <- nrow(extend(x[i, ]))
    if(n < nAll) attrX$.extended <- FALSE

  ## --- i can change sort ---

    rowName <- row.names(x)
    rowName <- rowName[rowName %in% i]
    if(!identical(order(i), order(rowName))) attrX$.sorted <- FALSE
  }

  ## --- j can remove some data ---

  ## which columns are selected
  colName <- names(x)
  if(is.character(args$j)) {
    colTest <- colName %in% args$j
  } else {
    colTest <- 1:nCol %in% args$j
  }

  if(!jMiss & !all(colTest)) {
    ## Which columns will be removed? - set their attributes to NA
    colName <- colName[!colTest]
    attrX[attrX %in% colName] <- NA
    ## Additional loss of information
    ascendant <- attr(x, ".ascendant")
    ascTest <- ascendant %in% colName
    attrX$.ascendant <- attrX$.ascendant[!ascTest]
    attrX$.ascendantLevel <- attrX$.ascendantLevel[!ascTest]
    attrX$.ascendantSex <- attrX$.ascendantSex[!ascTest]
    if(length(attrX$.ascendant) == 0) ## all ascendants were removed
      attrX$.ascendant <- attrX$.ascendantLevel <- attrX$.ascendantSex <- NA
    generation <- attr(x, ".generation")
    generTest <- generation %in% colName
    attrX$.generationOrder <- NA
  }

  ## --- Attributes and [.data.frame method ---

  args[is.na(args)] <- NULL ## remove unspecified args
  x <- do.call(what="[.data.frame", args=c(list(x=x), args))
  if(is.data.frame(x)) { ## set attributes back
    if(!iMiss) attrX$row.names <- row.names(x)
    if(!jMiss) attrX$names <- names(x)
    attributes(x) <- attrX
  }
  x
}

## "[<-.Pedigree" <- function(x, i, j, value)
## {
##
## }
##
## "[[", "[[<-"m "$", "$<-"
}

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### Pedigree.R ends here

### extend.R
###------------------------------------------------------------------------
### What: Extend Pedigree
### $Id: extend.R 1166 2007-04-03 14:00:55Z ggorjan $
### Time-stamp: <2007-04-03 13:02:45 ggorjan>
###------------------------------------------------------------------------

extend <- function(x, ascendant=NULL, col=NULL, top=TRUE)
{
  ## --- Setup ---

  x <- checkAttributes(x)
  subject <- attr(x, ".subject")
  if(is.null(ascendant)) ascendant <- attr(x, ".ascendant")

  ## --- Kernel ---

  for(i in seq(along=ascendant)) {

    ## Find ascendants that do not appear as subjects
    notIn <- (!(x[[ascendant[i]]] %in% x[[subject]]) &
              !x[[ascendant[i]]] %in% attr(x, ".unknown")$.id)
    tmp <- unique(x[[ascendant[i]]][notIn])
    tmpn <- length(tmp)
    if(tmpn > 0) {

      ## Collect structure from x, epand it and put in founders
      new <- x[0, ]
      new <- new[1:tmpn, ]
      row.names(new) <- NULL
      new[[subject]] <- tmp

      ## Sex
      sexAttr <- attr(x, ".sex")
      if(!is.na(sexAttr) & (is.null(col) | sexAttr %in% col)) {
        if(is.factor(new[[sexAttr]])) {
          new[[sexAttr]] <- factor(attr(x, ".ascendantSex")[i],
                                   levels=sort(attr(x, ".ascendantSex")))
        } else {
          new[[sexAttr]] <- attr(x, ".ascendantSex")[i]
        }
      }

      ## Generation
      genAttr <- attr(x, ".generation")
      if(!is.na(genAttr) & (is.null(col) | genAttr %in% col)) {
        if(attr(x, ".generationOrder") == "increasing") {
          fun <- min
        } else {
          fun <- max
        }
        ## Using c() to convert table to a vector
        new[[genAttr]] <- c(tapply(x[notIn, genAttr],
                                   as.character(x[notIn, ascendant[i]]), fun,
                                   na.rm=TRUE)) - 1
      }

      ## Date of birth
      ## FIXME: some method to possibly apply calculation of aproximate
      ## date of birth on average generation interval

      ## Extend
      x <- rbind(new, x)
      if(!top) {
        newN <- nrow(new)
        x <- x[c((newN + 1):nrow(x), 1:newN), ]
        ## FIXME: check if this order is appropriate one or should it be in
        ## any particular order specific to top
      }
    }
  }

  attr(x, ".extended") <- TRUE

  ## Family
  ## FIXME: commented out for the moment as there are many unresolved
  ## issues --> look into family.R
  ## famAttr <- attr(x, ".family")
  ## if(!is.na(famAttr) & (is.null(col) | famAttr %in% col))
  ##  family(x) <- family(x)

  ## --- End ---
  x
}

###------------------------------------------------------------------------
### extend.R ends here

### generatePedigree.R
###------------------------------------------------------------------------
### What: Generate Pedigree example
### $Id: generatePedigree.R 1096 2006-11-14 06:08:39Z ggorjan $
### Time-stamp: <2007-04-17 13:45:02 ggorjan>
###------------------------------------------------------------------------

## TODO: check for VB? note in slides
## TODO: implement option for multiple parents (fathers)

generatePedigree <- function(nId, nGeneration=3, nFather=round(nId/3),
                             nMother=nId-nFather, start=1,
                             generationOrder="increasing",
                             colClass="integer")
{
  ## --- Setup ---

  if(nId < 2) stop("'nId' must be at least 2")
  if((nFather + nMother) > nId)
    stop("'nFather' + 'nMother' must be lower or equal 'nId'")

  s <- round(nId * nFather/ (nFather + nMother))
  N <- nId * nGeneration
  x <- cbind(1:N, matrix(data=0, nrow=N, ncol=4))
  x[1:nId, 4] <- start
  for(i in 2:nGeneration) {
    ## Get parents
    base <- (i - 1) * nId
    fa <- (base - nId) + 1:nFather
    mo <- (base - nId + s) + 1:nMother
    ## Assign parents randomly
    x[(base + 1):(base + nId), 2] <- fa[ceiling(nFather * runif(n=nId))]
    x[(base + 1):(base + nId), 3] <- mo[ceiling(nMother * runif(n=nId))]
    x[(base + 1):(base + nId), 4] <- max(x[, 4]) + 1
  }

  ## Add sex
  x[x[, 1] %in% x[, 2], 5] <- 1
  x[x[, 1] %in% x[, 3], 5] <- 2
  tmp <- x[, 5] == 0
  x[tmp, 5] <- round(runif(n=sum(tmp), min=1, max=2))

  ## Column names and class stuff
  colnames(x) <- c("id", "father", "mother", "generation", "sex")
  if(colClass == "factor") {
    x <- data.frame(x)
    cols <- c("id", "father", "mother")
    x[, cols] <- as.data.frame(lapply(x[, cols], as.factor))
    cols <- c("generation", "sex")
    x[, cols] <- as.data.frame(lapply(x[, cols], as.integer))
  } else { # integers use less space
    x <- as.data.frame(lapply(data.frame(x), as.integer))
  }
  if(generationOrder == "decreasing")
    x$generation <- abs(x$generation - max(x$generation)) + start
  x <- as.Pedigree(x=x, unknown=0, sex="sex", generation="generation",
                   generationOrder=generationOrder)
  attr(x, ".extended") <- TRUE
  attr(x, ".sorted") <- TRUE
  if(colClass == "integer") {
    attr(x, ".coded") <- TRUE
  } else {
    attr(x, ".coded") <- FALSE
  }
  x
}

###------------------------------------------------------------------------
### generatePedigree.R

### buildPedigree.R
###------------------------------------------------------------------------
### What: Build pedigree for given individual(s)
### $Id: buildPedigree.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2007-09-06 23:35:06 ggorjan>
###------------------------------------------------------------------------

if(FALSE) {

## FIXME: .getAscendant is already taken for slot retrievel, perhaps
##        findAscendant or simpler ascendant

buildPedigree <- function(x, id)
{
  ## Build pedigree (up or down) for given individual(s)
  ## - I know hot to do it up
  ## - how to do it down?
  ##
  ## write getAscendant() and getDescendant() to get individuals and then
  ## simply collect rows from x and put them together
}

## Get something better than up for argument name; there should also be
## possibilty to use both "up" and "down" in buildPedigree()!

getAscendant <- function(x, id, up=TRUE)
{
  ## Get ascendants (relatives up) for given individuals(s)
}

getDescendant <- function(x, id)
{
  ## Get descendants (relatives down) for given individuals(s)
  getAscendant(x, id, up=FALSE)
}

getRelative <- function(x, id)
{
  ## Get relatives (up or down) for given individuals(s)
  ## But is this only
  ##
  ## ...
  ## ff fm  mf mm
  ##   f      m
  ##      a
  ##   p1   p2
  ## gp1 gp2 gp3 gp4
  ## ...
  ##
  ## Or should we list all individuals that are in relationship with
  ## individual i.e. all individuals that have A[,] > 0?

  ## The second option, as first one will be covered with getAscendant()
  ## and getDescendant()
}

}

###------------------------------------------------------------------------
### buildPedigree.R ends here

### generateData.R
###------------------------------------------------------------------------
### What: Generate data based on pedigree
### $Id: generateData.R 1092 2006-11-12 12:28:38Z ggorjan $
### Time-stamp: <2006-09-26 20:33:31 ggorjan>
###------------------------------------------------------------------------

## - create base
## - "evolve" i.e. random mating, selection
##   would we need addIndividual() here?

## generateData(nGenerations=10,
##              nBase=1000,
##              base=generateBase(),
##              evolve/select=evolve/select(),
##              mate="random|else correlation for assortative",
##              effects="is it possible to create specific for lab. experiments
##                       and national gen. system",
##              ...)

## generateBase(n=nBase,
##              mu,
##              Sigma)
## {
##   mvrnorm(n=n, mu=, Sigma)
##   ## Multitrait
## }

## a[i] <- 0.5 * sire[i] + 0.5 * dam[i] + rnorm(0, sigma^2_mendelian)

###------------------------------------------------------------------------
### generateData.R ends here

### relationshipAdditive.R
###------------------------------------------------------------------------
### What: Additive relationship matrix (A)
### $Id: relationshipAdditive.R 1184 2007-04-04 07:06:22Z ggorjan $
### Time-stamp: <2007-04-04 09:04:37 ggorjan>
###------------------------------------------------------------------------

### {{{ relationshipAdditive
###------------------------------------------------------------------------

## relationshipAdditive <- function(x, sort=TRUE, names=TRUE, ...)
## {
##   ## --- Setup ---

##   subject <- attr(x, ".subject")
##   ascendant <- attr(x, ".ascendant")
##   if(length(ascendant) > 2)
##       stop("no method for pedigree with more than two ascendants")
##   if(sort) idOrig <- as.character(x[[subject]])  # for sorting-back

##   ## Pedigree must be sorted and extended
##   x <- checkAttributes(x, sorted=TRUE, extended=TRUE)

##   n <- nrow(x)
##   ret <- matrix(0, n, n)          # n*n matrix
##   diag(ret) <- 1                  # diagonal is at least 1
##   rownames(ret) <- colnames(ret) <- x[[subject]]

##   asc1 <- as.character(x[[ascendant[1]]])
##   asc2 <- as.character(x[[ascendant[2]]])
##   testAsc1 <- !isUnknown(x[[ascendant[1]]])
##   testAsc2 <- !isUnknown(x[[ascendant[2]]])
##   testAsc  <- testAsc1 & testAsc2
##   ## subjects with at least one ascendant known
##   set <- which(!(!testAsc1 & !testAsc2))

##   ## --- Core ---

##   for(i in set) {
##     ## Diagonal
##     if(testAsc[i]) ret[i, i] <- 1 + 0.5 * ret[asc1[i], asc2[i]]
##     ## Off-diagonal
##     j <- 1:(i - 1)                # working with lower triangle
##     if(testAsc1[i]) tmp <-       0.5 * ret[asc1[i], j]
##     if(testAsc2[i]) tmp <- tmp + 0.5 * ret[asc2[i], j]
##     ret[i, j] <- ret[j, i] <- tmp
##   }

##   ## --- End ---

##   if(sort) ret <- ret[idOrig, idOrig]
##   if(!names) attr(ret, which="dimnames") <- NULL
##   ret
## }

relationshipAdditive <- function(x, sort=TRUE, names=TRUE, ...){
    ## --- Setup ---
    subject <- attr(x, ".subject")
    ascendant <- attr(x, ".ascendant")
    if(length(ascendant) > 2)
        stop("no method for pedigree with more than two ascendants")
    if(sort) idOrig <- as.character(x[[subject]]) # for sorting-back
    ## Pedigree must be sorted and extended
    x <- checkAttributes(x, sorted=TRUE, extended=TRUE)
    n <- nrow(x)
    ret <- matrix(0, n, n) # n*n matrix
    diag(ret) <- 1 # diagonal is at least 1
    rownames(ret) <- colnames(ret) <- x[[subject]]
    asc1 <- as.character(x[[ascendant[1]]])
    asc2 <- as.character(x[[ascendant[2]]])
    testAsc1 <- !isUnknown(x[[ascendant[1]]])
    testAsc2 <- !isUnknown(x[[ascendant[2]]])
    testAsc <- testAsc1 & testAsc2

    ## subjects with at least one ascendant known
    set <- which(!(!testAsc1 & !testAsc2))
    ## --- Core ---
    for(i in set) {
        ## Diagonal
        if(testAsc[i]) ret[i, i] <- 1 + 0.5 * ret[asc1[i], asc2[i]]
        ## Off-diagonal
        j <- 1:(i - 1) # working with lower triangle
        if( testAsc1[i] )
        {
            tmp1 <- 0.5 * ret[asc1[i], j]
        }
        else
        {
            tmp1 <- 0
        }
        if( testAsc2[i] )
        {
            tmp2 <- 0.5 * ret[asc2[i], j]
        }
        else
        {
            tmp2 <- 0
        }
        ret[i, j] <- ret[j, i] <- tmp1 + tmp2
    }

    ## --- End ---
    if(sort) ret <- ret[idOrig, idOrig]
    if(!names) attr(ret, which="dimnames") <- NULL
    ret
}

### }}}
### {{{ kinship
###------------------------------------------------------------------------

kinship <- function(x, sort=TRUE, names=TRUE, ...)
  relationshipAdditive(x, sort=sort, names=names, ...) / 2

### }}}
### {{{ Dear Emacs
## Local variables:
## folded-file: t
## End:
### }}}

###------------------------------------------------------------------------
### relationshipAdditive.R ends here

% pedigreeHandling.Rnw
% -------------------------------------------------------------------------
% What: Pedigree handling vignette
% $Id: pedigreeHandling.Rnw 1179 2007-04-03 14:13:02Z ggorjan $
% Time-stamp: <2007-04-01 01:09:08 ggorjan>
% -------------------------------------------------------------------------

% --- Vignette stuff ---
% -------------------------------------------------------------------------

%\VignetteIndexEntry{Pedigree handling}
%\VignettePackage{GeneticsPed}
%\VignetteDepends{gdata}
%\VignetteKeywords{genetics, pedigree, parents, children, progeny, ancestor, ascendant, descendant, generation, sex, birth date, family}

% --- Preamble ---
% -------------------------------------------------------------------------

% Document class and general packages
% -------------------------------------------------------------------------
\documentclass[fleqn,a4paper]{article}  % fleqn - allignment of equations
                                        % a4paper appropriate page size

\usepackage{graphicx}                   % For inclusion of pictures, ...
\usepackage[authoryear]{natbib}         % Bibliography - Natbib
\newcommand{\SortNoop}[1]{}             % Sort command for bib entries
\usepackage{hyperref}

\hypersetup{%
  pdftitle={Pedigree handling},
  pdfauthor={Gregor Gorjanc},
  pdfkeywords={genetics, pedigree, parents, children, progeny, ancestor,
    ascendant, descendant, generation, sex, birth date, family}
}

\newcommand{\email}[1]{\href{mailto:#1}{#1}} % Email command

\makeatletter                           % Allow the use of @ in command names

% Paragraph and page
% -------------------------------------------------------------------------

\usepackage{setspace}                   % Line spacing
\onehalfspacing
\setlength\parskip{\medskipamount}
\setlength\parindent{0pt}

% --- Lyx Tips&Tricks: better formatting, less hyphenation problems ---
\tolerance 1414
\hbadness 1414
\emergencystretch 1.5em
\hfuzz 0.3pt
\widowpenalty=10000
\vfuzz \hfuzz
\raggedbottom

% Page size
\usepackage{geometry}
\geometry{verbose,a4paper,tmargin=3.0cm,bmargin=3.0cm,lmargin=2.5cm,
  rmargin=2.5cm,headheight=20pt,headsep=0.7cm,footskip=12pt}

\makeatother                            % Cancel the effect of \makeatletter

% R and friends
% -------------------------------------------------------------------------

\newcommand{\program}[1]{{\textit{\textbf{#1}}}}
\newcommand{\code}[1]{{\texttt{#1}}}

% http://www.bioconductor.org/develPage/guidelines/vignettes/vignetteGuidelines.pdf
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}
\newcommand{\Rfunarg}[1]{{\textit{#1}}}

\newcommand{\R}{\program{R}}

\usepackage{Sweave}                     % Sweave
\SweaveOpts{strip.white=all, keep.source=TRUE}

<<options, echo=FALSE, results=hide>>=
options(width=85)
@

% --- Document ---
% -------------------------------------------------------------------------

\begin{document}

\title{Pedigree handling}
\author{
  Gregor Gorjanc\\
  \email{gregor.gorjanc@bfro.uni-lj.si},\\
  David A. Henderson\\
  \email{dnadave@insightful.com}
}

\maketitle

\section*{Introduction}

Pedigrees are collections of related individuals.  Often we represent these as a
linked list, a collection of trios that links (or almost everyone) everyone
together: an individual and its two parents.  This simple representation allows
the use of graph theory in analysis.  The GeneticsPed package provides utilities
for managing pedigrees; inputing, sorting, and subsetting pedigrees; and
computing on pedigrees by calculating relationship coefficients and other
similar quantities.

name some fields were pedigree is used
\cite{Falconer:1996}

\section*{?}

Pedigree class

\subsection*{}

describe

individual
subject
ascendant

can be factor, character, numeric, but all must have the same class

\subsection*{Unknown individuals}

FIXME
Pedigrees are never complete because it is not possible to get data on all
ascendants. Therefore there are always some subjects with unknown
ascendants. As with pedigree form there are also differences in
representation of unknown individuals between different applications,
namely using 0, blank field, particular string as ``unknown'', etc. In
GeneticsPed R's unknown representation \code{NA} is used. Change from other
representations to \code{NA} can be done prior to definition of a pedigree
object. To ease this process, we have provided argument \code{unknown} in
\Rfunction{Pedigree}. Multiple values can be passed to that argument in one
call i.e. \code{uknown=c(0, "", "unknown")}. Internally, change is done via
\Rfunction{uknownToNA} generic function. In case one wants to use some
other representation for example for special application in R or exporting
to outer application, \Rfunction{NAToUknown} function is provided.

How will we handle if one wants anything else than 0 in R - should we allow
for this or just convert each time to NA in our functions?


<<bla>>=
1+1
@

\section{Check consistency of data in pedigree}

check

check.Pedigree
checkId

check performs a series of checks on
  pedigree object to ensure consistency of data.

check(x, $\ldots$)
checkId(x)


\begin{itemize}
  \item[x] pedigree, object to be checked
  \item[]$\ldots$] arguments to other methods, none for now
\end{itemize}

  checkId performs various checks on subjects and
  their ascendants. These checks are:
\begin{itemize}
    \item idClass: all ids must have the same class
    \item subjectIsNA: subject can not be NA
    \item subjectNotUnique: subject must be unique
    \item subjectEqualAscendant: subject can not be equal (in
      identification) to its ascendant
    \item ascendantEqualAscendant: ascendant can not be equal to another
      ascendant
    \item ascendantInAscendant: ascendant can not appear again as
      asescendant of other sex i.e. father can not be a mother to someone
      else
    \item unusedLevels: in case factors are used for id presentation,
      there might be unused levels for some ids - some functions rely on
      number of levels and a check is provided for this
\end{itemize}

  checkAttributes is intended primarly for internal use and
  performs a series of checks on attribute values needed in various
  functions. It causes stop with error messages for all given attribute
  checks.


List of more or less self-explanatory errors and "pointers" to
  these errors for ease of further work i.e. removing errors.

\begin{verbatim}
  ## EXAMPLES BELLOW ARE ONLY FOR TESTING PURPOSES AND ARE NOT INTENDED
  ## FOR USERS, BUT IT CAN NOT DO ANY HARM.

  ## --- checkAttributes ---
  tmp <- generatePedigree(5)
  attr(tmp, "sorted") <- FALSE
  attr(tmp, "coded") <- FALSE
  GeneticsPed:::checkAttributes(tmp)
  try(GeneticsPed:::checkAttributes(tmp, sorted=TRUE, coded=TRUE))

  ## --- idClass ---
  tmp <- generatePedigree(5)
  tmp$id <- factor(tmp$id)
  class(tmp$id)
  class(tmp$father)
  try(GeneticsPed:::idClass(tmp))

  ## --- subjectIsNA ---
  tmp <- generatePedigree(2)
  tmp[1, 1] <- NA
  GeneticsPed:::subjectIsNA(tmp)

  ## --- subjectNotUnique ---
  tmp <- generatePedigree(2)
  tmp[2, 1] <- 1
  GeneticsPed:::subjectNotUnique(tmp)

  ## --- subjectEqualAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[3, 1]
  GeneticsPed:::subjectEqualAscendant(tmp)

  ## --- ascendantEqualAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[3, 3]
  GeneticsPed:::ascendantEqualAscendant(tmp)

  ## --- ascendantInAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[5, 3]
  GeneticsPed:::ascendantInAscendant(tmp)
  ## Example with multiple parents
  tmp <- data.frame(id=c("A", "B", "C", "D"),
                    father1=c("E", NA, "F", "H"),
                    father2=c("F", "E", "E", "I"),
                    mother=c("G", NA, "H", "E"))
  tmp <- Pedigree(tmp, ascendant=c("father1", "father2", "mother"),
                  ascendantSex=c(1, 1, 2),
                  ascendantLevel=c(1, 1, 1))
  GeneticsPed:::ascendantInAscendant(tmp)

  ## --- unusedLevels ---
  tmp <- generatePedigree(2, colClass="factor")
  tmp[3:4, 2] <- NA
  GeneticsPed:::unusedLevels(tmp)
\end{verbatim}

\bibliographystyle{apalike}
\bibliography{library}

\end{document}

% -------------------------------------------------------------------------
% pedigreeHandling.Rnw ends here

% geneticRelatedness.Rnw
% -------------------------------------------------------------------------
% What: Vignette on calculation of genetic relatedness between individuals
%       in the pedigree
% $Id: geneticRelatedness.Rnw 1179 2007-04-03 14:13:02Z ggorjan $
% Time-stamp: <2007-04-01 01:08:51 ggorjan>
% -------------------------------------------------------------------------

% --- Vignette stuff ---
% -------------------------------------------------------------------------

%\VignetteIndexEntry{Calculation of genetic relatedness/relationship between individuals in the pedigree}
%\VignettePackage{GeneticsPed}
%\VignetteDepends{gdata}
%\VignetteKeywords{genetics, relatedness, relationship, kinship, inbreeding, additive, dominance, epistatic}

% --- Preamble ---
% -------------------------------------------------------------------------

% Document class and general packages
% -------------------------------------------------------------------------
\documentclass[fleqn,a4paper]{article}  % fleqn - allignment of equations
                                        % a4paper appropriate page size

\usepackage[authoryear]{natbib}         % Bibliography - Natbib
\newcommand{\SortNoop}[1]{}             % Sort command for bib entries
\usepackage{hyperref}

\hypersetup{%
  pdftitle={Calculation of genetic relatedness/relationship between individuals
    in the pedigree},
  pdfauthor={Gregor Gorjanc and David A. Henderson},
  pdfkeywords={genetics, relatedness, relationship, kinship, inbreeding,
    additive, dominance, epistatic}
}

\newcommand{\email}[1]{\href{mailto:#1}{#1}} % Email command

\makeatletter                           % Allow the use of @ in command names

% Paragraph and page
% -------------------------------------------------------------------------

\usepackage{setspace}                   % Line spacing
\onehalfspacing
\setlength\parskip{\medskipamount}
\setlength\parindent{0pt}

% --- Lyx Tips&Tricks: better formatting, less hyphenation problems ---
\tolerance 1414
\hbadness 1414
\emergencystretch 1.5em
\hfuzz 0.3pt
\widowpenalty=10000
\vfuzz \hfuzz
\raggedbottom

% Page size
\usepackage{geometry}
\geometry{verbose,a4paper,tmargin=3.0cm,bmargin=3.0cm,lmargin=2.5cm,
  rmargin=2.5cm,headheight=20pt,headsep=0.7cm,footskip=12pt}

\makeatother                            % Cancel the effect of \makeatletter

% R and friends
% -------------------------------------------------------------------------

\newcommand{\program}[1]{{\textit{\textbf{#1}}}}
\newcommand{\code}[1]{{\texttt{#1}}}

% http://www.bioconductor.org/develPage/guidelines/vignettes/vignetteGuidelines.pdf
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}
\newcommand{\Rfunarg}[1]{{\textit{#1}}}

\newcommand{\R}{\program{R}}

\usepackage{Sweave}                     % Sweave
\SweaveOpts{strip.white=all, keep.source=TRUE}

<<options, echo=FALSE, results=hide>>=
options(width=85)
@

% --- Document ---
% -------------------------------------------------------------------------

\begin{document}

\title{Calculation of genetic relatedness/relationship between individuals
  in the pedigree}

\author{
  Gregor Gorjanc\\
  \email{gregor.gorjanc@bfro.uni-lj.si},\\
  David A. Henderson\\
  \email{dnadave@insightful.com}
}

\maketitle

\section*{Introduction}

\section*{?}

\subsection*{Kinship?}

\cite{Wright:1922}, Malecot 1948, Emik and Terill 1949

\cite{Falconer:1996}
\cite{LynchWalsh:1998}


\cite{Meuwissen:1992}
\cite{Boichard:2002}
\cite{Sargolzaei:2005}

\cite{Oliehoek:2006} on various relatedness estimators between individuals
in general i.e. panmictic and structured populations.

<<bla>>=
1+1
@

\bibliographystyle{apalike}
\bibliography{library}

\end{document}

% -------------------------------------------------------------------------
% geneticRelatedness.Rnw ends here

% quanGenAnimalModel.Rnw
% -------------------------------------------------------------------------
% What: Vignette on quantitative genetic (animal) model example in R
% $Id: quanGenAnimalModel.Rnw 1178 2007-04-03 14:11:47Z ggorjan $
% Time-stamp: <2007-04-03 13:00:35 ggorjan>
% -------------------------------------------------------------------------

% --- Vignette stuff ---
% -------------------------------------------------------------------------

%\VignetteIndexEntry{Quantitative genetic (animal) model example in R}
%\VignettePackage{GeneticsPed}
%\VignetteDepends{gdata}
%\VignetteKeywords{phenotype data, pedigree, quantitative genetics, animal model, BLUP, breeding values}

% --- Preamble ---
% -------------------------------------------------------------------------

% Document class and general packages
% -------------------------------------------------------------------------
\documentclass[fleqn,a4paper]{article}  % fleqn - allignment of equations
                                        % a4paper appropriate page size

\usepackage[authoryear]{natbib}         % Bibliography - Natbib
\newcommand{\SortNoop}[1]{}             % Sort command for bib entries
\usepackage{hyperref}

\hypersetup{%
  pdftitle={Quantitative genetic (animal) model example in R},
  pdfauthor={Gregor Gorjanc},
  pdfkeywords={phenotype data, pedigree, quantitative genetics, animal model,
    BLUP, breeding values}
}

\newcommand{\email}[1]{\href{mailto:#1}{#1}} % Email command

\makeatletter                           % Allow the use of @ in command names

% Paragraph and page
% -------------------------------------------------------------------------

\usepackage{setspace}                   % Line spacing
\onehalfspacing
\setlength\parskip{\medskipamount}
\setlength\parindent{0pt}

% --- Lyx Tips&Tricks: better formatting, less hyphenation problems ---
\tolerance 1414
\hbadness 1414
\emergencystretch 1.5em
\hfuzz 0.3pt
\widowpenalty=10000
\vfuzz \hfuzz
\raggedbottom

% Page size
\usepackage{geometry}
\geometry{verbose,a4paper,tmargin=3.0cm,bmargin=3.0cm,lmargin=2.5cm,
  rmargin=2.5cm,headheight=20pt,headsep=0.7cm,footskip=12pt}

\makeatother                            % Cancel the effect of \makeatletter

% R and friends
% -------------------------------------------------------------------------

\newcommand{\program}[1]{{\textit{\textbf{#1}}}}
\newcommand{\code}[1]{{\texttt{#1}}}

% http://www.bioconductor.org/develPage/guidelines/vignettes/vignetteGuidelines.pdf
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}
\newcommand{\Rfunarg}[1]{{\textit{#1}}}

\newcommand{\R}{\program{R}}

\usepackage{Sweave}                     % Sweave
\SweaveOpts{strip.white=all, keep.source=TRUE}

<<options, echo=FALSE, results=hide>>=
options(width=85)
@

% --- Document ---
% -------------------------------------------------------------------------

\begin{document}

\title{Quantitative genetic (animal) model example in \R{}}
\author{
  Gregor Gorjanc\\
  \email{gregor.gorjanc@bfro.uni-lj.si}
}

\maketitle

\section*{Introduction}

The following is just a quick introduction to quantitative genetic model,
which is usually called animal model in animal breeding scenario. This
model provides inferences on parameters such as genetic (additive/breeding,
dominance, \ldots) values and possibly also co-variance components
(additive genetic variance, heritability, \ldots). Very nice introduction
to this topic is in \cite{Mrode:2005}, which also gives a list of key
references. We use example from this book and will therefore be very brief.

This note is mainly for educational purposes. There are quite some programs
(e.g. \cite{Druet:2006:ISP} mentions \program{ASReml}, \program{BGF90},
\program{DFREML}, \program{DMU}, \program{MATVEC}, \program{PEST/VCE} and
\program{WOMBAT}) that can fit animal models in a general manner and we
suggest to take a look at them instead of trying to reinvent the wheel in
\R{}.

In short animal model is an example of a mixed model:

\[ \mathbf{y} = \mathbf{X}\mathbf{b} + \mathbf{Z}\mathbf{u} + \mathbf{e},\]

where $\mathbf{y}$ represents a vector of observed (measured) phenotype
values, $\mathbf{b}$ and $\mathbf{u}$ are vectors of unknown parameters for
``fixed'' and ``random'' effects, while $\mathbf{X}$ and $\mathbf{Z}$ are
corresponding design matrices and finally $\mathbf{e}$ is a vector of
residuals. Assuming normal density for $\mathbf{y}$ the following
standard assumptions are taken:

\[
\left(
\begin{array}{c}
\mathbf{y}\\
\mathbf{u}\\
\mathbf{e}
\end{array}\right) \sim
N\left(\begin{array}{c}
\mathbf{X}\mathbf{b}\\
\mathbf{0}\\
\mathbf{0}
\end{array},
\begin{array}{ccc}
\mathbf{V}               & \mathbf{Z}\mathbf{G} & \mathbf{R}\\
\mathbf{G}\mathbf{Z}^{'} & \mathbf{G}           & \mathbf{0}\\
\mathbf{R}               & \mathbf{0}           & \mathbf{R}
\end{array}\right),
\mathbf{V}=\mathbf{Z}\mathbf{G}\mathbf{Z}^{'}+\mathbf{R}
\]

Up to now all this is as in usual mixed model. Genetic aspect comes from
specification of covariance matrix between elements of $\mathbf{u}$, which
usually represents sum of additive effects of genes of individuals in the
pedigree.  For a univariate model the covariance matrix of additive effect
can be written as $\mathbf{G}=\mathbf{A}\sigma^2_u$, where $\mathbf{A}$
is additive/numerator relationship matrix \citep{Wrigth:1922} and
$\sigma^2_u$ is additive genetic variance \citep{Falconer:1996}.

\section*{Mixed model equations (MME)}

Solution for $\mathbf{b}$ i.e. (E)BLUE and $\mathbf{u}$ i.e. (E)BLUP can be
obtained from \citep{Henderson:1949,Goldberger:1962,Henderson:1963}:

\[
\hat{\mathbf{b}}=\left(\mathbf{X}\mathbf{V}^{-1}\mathbf{X}\right)^{-}\mathbf{X}\mathbf{V}^{-1}\mathbf{y},\]

and

\[
\hat{\mathbf{u}}=\mathbf{G}\mathbf{Z}^{'}\mathbf{V}^{-1}\left(\mathbf{y}-\mathbf{X}\hat{\mathbf{b}}\right),\]

but in a case with a lot of records the size of $\mathbf{V}$ is huge and
its direct inverse prohibitive if possible at all. \cite{Henderson:1950}
presented the solution to this problem with so called mixed model
equations:

\[
\left(\begin{array}{cc}
\mathbf{X}^{'}\mathbf{R}^{-1}\mathbf{X} & \mathbf{X}^{'}\mathbf{R}^{-1}\mathbf{Z}\\
\mathbf{Z}^{'}\mathbf{R}^{-1}\mathbf{X} & \mathbf{Z}^{'}\mathbf{R}^{-1}\mathbf{Z}+\mathbf{G}^{-1}\end{array}\right)\left(\begin{array}{c}
\hat{\mathbf{b}}\\
\hat{\mathbf{u}}\end{array}\right)=\left(\begin{array}{c}
\mathbf{X}^{'}\mathbf{R}^{-1}\mathbf{y}\\
\mathbf{Z}^{'}\mathbf{R}^{-1}\mathbf{y}\end{array}\right).\]

\section*{Data}

We will use pedigree and data example from \cite{Mrode:2005}. Example shows
a beef breeding scenario with 8 individuals (animals), where 5 of them have
phenotype records (pre-weaning gain in kg) and 3 three of them are without
records and link others through the pedigree.

<<data>>=
library(GeneticsPed)
data(Mrode3.1)
(x <- Pedigree(x=Mrode3.1, subject="calf", ascendant=c("sire", "dam"),
               ascendantSex=c("Male", "Female"), sex="sex"))
@

\section*{The model}


For this baby BLUP example we will postulate the following model:

\[ y_{ij} = s_i + a_j + e_{ij},\]

where $y_{ij}$ is pre-weaning gain (kg) of calf $j$ of sex $j$; $s_i$ are
parameters of sex effect, while $a_j$ are parameters of additive genetic
effect for pre-weaning gain and finally $e_{ij}$ is residual. Variances for
$a_j$ and $e_{ij}$ are assumed as $\mathbf{G}=\mathbf{A}\sigma^2_a$ with
$\sigma^2_a=20~kg^2$ and $\mathbf{R}=\mathbf{I}\sigma^2_e$ with
$\sigma^2_e=40~kg^2$.

\section*{Setting up the MME}

Observed/measured phenotype records:

<<y>>=
(y <- x$pwg)
@

Design matrix ($\mathbf{X}$) for sex effect:

<<X>>=
X <- model.matrix(~ x$sex - 1)
t(X)
@

Design matrix ($\mathbf{Z}$) for additive genetic effect. Note that first
three columns do not have indicators since these columns are for
individuals without phenotype records and apear in the model only through
the pedigree.

<<Z>>=
(Z <- model.matrix(object=x, y=x$pwg, id=x$calf))
@

Left hand side (LHS) of MME without $\mathbf{G}^{-1}$:

<<LHS>>=
LHS <- rbind(cbind(t(X) %*% X, t(X) %*% Z),
             cbind(t(Z) %*% X, t(Z) %*% Z))
## or more efficiently
(LHS <- rbind(cbind(crossprod(X),    crossprod(X, Z)),
              cbind(crossprod(Z, X), crossprod(Z))))
@

and adding $\mathbf{G}^{-1}$, which is in this case $\mathbf{A}^{-1}\alpha$
and $\alpha = \frac{\sigma^2_e}{\sigma^2_a} =\frac{40}{20}=2$.

<<LHS2>>=
## We want Ainv for all individuals in the pedigree not only individuals
##   with records
x <- extend(x)
Ainv <- inverseAdditive(x=x)
sigma2a <- 20
sigma2e <- 40
alpha <- sigma2e / sigma2a
q <- nIndividual(x)
p <- nrow(LHS) - q
(LHS[(p + 1):(p + q), (p + 1):(p + q)] <-
 LHS[(p + 1):(p + q), (p + 1):(p + q)] + Ainv * alpha)
@

Right hand side (RHS) of MME:

<<RHS>>=
RHS <- rbind(t(X) %*% y,
             t(Z) %*% y)
## or more efficiently
RHS <- rbind(crossprod(X, y),
             crossprod(Z, y))
t(RHS)
@

\section*{Solution}

<<solve>>=
sol <- solve(LHS) %*% RHS
## or more efficiently
sol <- solve(LHS, RHS)
t(sol)
@

That's all folks! Well, all for the introduction. There are numerous issues
covered in the literature. A good starting point is \cite{Mrode:2005} as
already mentioned in the beginning.

\section*{R Session information}

<<sessionInfo, results=tex>>=
toLatex(sessionInfo())
@

\bibliographystyle{apalike}
\bibliography{library}

\end{document}

% -------------------------------------------------------------------------
% quanGenAnimalModel.Rnw ends here

% geneFlowT.Rd
%--------------------------------------------------------------------------
% What: Create gene and gamete flow matrices
% $Id: TDT.Rd 1168 2007-04-03 14:03:43Z ggorjan $
% Time-stamp: <2007-04-01 23:11:34 ggorjan>
%--------------------------------------------------------------------------

\name{geneFlowT}

\alias{geneFlowT}
\alias{geneFlowTinv}
\alias{gameteFlowM}
\alias{mendelianSamplingD}

\concept{relationship}
\concept{relatedness}
\concept{genetic covariance}

\title{Gene and gamete flow matrices}

\description{

\code{geneFlowT} and \code{geneFlowTinv} creates gene flow matrix (T)
and its inverse (Tinv), while \code{gameteFlowM} creates gamete flow
matrix (M). \code{mendelianSamplingD} creates a mendelian sampling
covariance matrix (D).

}

\usage{

geneFlowT(x, sort=TRUE, names=TRUE, \ldots)
geneFlowTinv(x, sort=TRUE, names=TRUE, \ldots)
gameteFlowM(x, sort=TRUE, names=TRUE, \ldots)
mendelianSamplingD(x, matrix=TRUE, names=TRUE, \ldots)

}

\arguments{
  \item{x}{Pedigree}
  \item{sort}{logical, for the computation the pedigree needs to be
    sorted, but results are sorted back to original sorting (sort=TRUE)
    or not (sort=FALSE)}
  \item{names}{logical, should returned matrix have row/colnames; this
    can be used to get leaner matrix}
  \item{matrix}{logical, should returned value be a diagonal matrix or a
    vector}
  \item{\ldots}{arguments for other methods}
}

\details{

\code{geneFlowT} returns a matrix with coefficients that show the flow
of genes from one generation to the next one etc. \code{geneFlowTinv} is
simply the inverse of \code{geneFlowT}, but calculated as \eqn{I - M},
where \eqn{M} is gamete flow matrix with coefficients that represent
parent gamete contribution to their offspring. \code{mendelianSamplingD}
is another matrix (\eqn{D}) for construction of relationship additive
matrix via decomposition i.e. \eqn{A=TDT'} (Henderson, 1976). Mrode
(2005) has a very nice introduction to these concepts.

Take care with \code{sort=FALSE, names=FALSE}. It is your own
responsibility to assure proper handling in this case.

}

\value{Matrices of \eqn{n * n} dimension, with coeficients as described in the
details, where \eqn{n} is number of subjects in \code{x}}

\references{

Henderson, C. R. (1976) A simple method for computing the inverse of a
numerator relationship matrix used in prediction of breeding
values. \emph{Biometrics} \bold{32}(1):69-83

Mrode, R. A. (2005) Linear models for the prediction of animal breeding
values. 2nd edition. CAB International. ISBN 0-85199-000-2
\url{http://www.amazon.com/gp/product/0851990002}

}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}, \code{\link{relationshipAdditive}},
\code{\link{kinship}} and \code{\link{inbreeding}}}

\examples{
if(require(gdata))
  data(Mrode2.1)
  Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
  x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                   ascendantSex=c("M", "F"), family="fam", sex="sex",
                   generation="gen", dtBirth="dtB")

  fractions(geneFlowT(x2.1))
  fractions(geneFlowTinv(x2.1))
  fractions(gameteFlowM(x2.1))
  mendelianSamplingD(x2.1)
}

\keyword{array}
\keyword{misc}

%--------------------------------------------------------------------------
% geneFlowT.Rd ends here

% check.Rd
%--------------------------------------------------------------------------
% What: Check Pedigree attributes
% $Id: check.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2007-09-20 13:21:45 ggorjan>
%--------------------------------------------------------------------------

\name{check}

\alias{check}
\alias{check.Pedigree}
\alias{checkId}

\title{Check consistency of data in pedigree}

\description{\code{check} performs a series of checks on
  pedigree object to ensure consistency of data.
}

\usage{
check(x, \ldots)
checkId(x)
}

\arguments{
  \item{x}{pedigree, object to be checked}
  \item{\ldots}{arguments to other methods, none for now}
}

\details{

  \code{checkId} performs various checks on individuals and
  their ascendants. These checks are:
  \itemize{
    \item idClass: all ids must have the same class
    \item idIsNA: individual can not be \code{NA}
    \item idNotUnique: individual must be unique
    \item idEqualAscendant: individual can not be equal
      to its ascendant
    \item ascendantEqualAscendant: ascendant can not be equal to another
      ascendant
    \item ascendantInAscendant: ascendant can not appear again as
      asescendant of other sex i.e. father can not be a mother to someone
      else
    \item unusedLevels: in case factors are used for id presentation,
      there might be unused levels for some ids - some functions rely on
      number of levels and a check is provided for this
  }

  \code{checkAttributes} is intended primarly for internal use and
  performs a series of checks on attribute values needed in various
  functions. It causes stop with error messages for all given attribute
  checks.
}

\value{List of more or less self-explanatory errors and "pointers" to
  these errors for ease of further work i.e. removing errors.
}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ## EXAMPLES BELLOW ARE ONLY FOR TESTING PURPOSES AND ARE NOT INTENDED
  ## FOR USERS, BUT IT CAN NOT DO ANY HARM.

  ## --- checkAttributes ---
  tmp <- generatePedigree(5)
  attr(tmp, "sorted") <- FALSE
  attr(tmp, "coded") <- FALSE
  GeneticsPed:::checkAttributes(tmp)
  try(GeneticsPed:::checkAttributes(tmp, sorted=TRUE, coded=TRUE))

  ## --- idClass ---
  tmp <- generatePedigree(5)
  tmp$id <- factor(tmp$id)
  class(tmp$id)
  class(tmp$father)
  try(GeneticsPed:::idClass(tmp))

  ## --- idIsNA ---
  tmp <- generatePedigree(2)
  tmp[1, 1] <- NA
  GeneticsPed:::idIsNA(tmp)

  ## --- idNotUnique ---
  tmp <- generatePedigree(2)
  tmp[2, 1] <- 1
  GeneticsPed:::idNotUnique(tmp)

  ## --- idEqualAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[3, 1]
  GeneticsPed:::idEqualAscendant(tmp)

  ## --- ascendantEqualAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[3, 3]
  GeneticsPed:::ascendantEqualAscendant(tmp)

  ## --- ascendantInAscendant ---
  tmp <- generatePedigree(2)
  tmp[3, 2] <- tmp[5, 3]
  GeneticsPed:::ascendantInAscendant(tmp)
  ## Example with multiple parents
  tmp <- data.frame(id=c("A", "B", "C", "D"),
                    father1=c("E", NA, "F", "H"),
                    father2=c("F", "E", "E", "I"),
                    mother=c("G", NA, "H", "E"))
  tmp <- Pedigree(tmp, ascendant=c("father1", "father2", "mother"),
                  ascendantSex=c(1, 1, 2),
                  ascendantLevel=c(1, 1, 1))
  GeneticsPed:::ascendantInAscendant(tmp)

  ## --- unusedLevels ---
  tmp <- generatePedigree(2, colClass="factor")
  tmp[3:4, 2] <- NA
  GeneticsPed:::unusedLevels(tmp)
}

\keyword{misc}
\keyword{attribute}

%--------------------------------------------------------------------------
% check.Rd ends here

% gpiUtil.Rd
%--------------------------------------------------------------------------
% What: Utility functions for gpi()
% $Id$
% Time-stamp: <2007-09-13 03:23:16 ggorjan>
%--------------------------------------------------------------------------

\name{hwp}
\alias{hwp}
\alias{gpLong2Wide}

\title{Utility functions for gpi()}

\description{

\code{gpLong2Wide} changes data.frame with genotype probabilities in
long form (one genotype per row) to wide form (one individual per row)
for use in \code{\link{gpi}}.

\code{hwp} calculates genotype probabilities according to Hardy-Weinberg
law for use in \code{\link{gpi}}.

}

\usage{
  gpLong2Wide(x, id, genotype, prob, trim=TRUE)
  hwp(x, trim=TRUE)
}

\arguments{
  \item{x}{data.frame for \code{gpLong2Wide},
    \code{\link[genetics]{genotype}} for \code{hwp}}
  \item{id}{character, column name in \code{x} holding individual
    identifications}
  \item{genotype}{character, column name in \code{x} holding genotypes}
  \item{prob}{character, column name in \code{x} holding genotype
    probabilities}
  \item{trim}{logical, remove last column (for \code{gpLong2Wide}) or
    value (for \code{hwp}) of a result}
}

\details{

Hardy-Weinberg probabilities for a gene with two alleles A and B, with
probabilities \eqn{Pr(A)} and \eqn{Pr(B)} are:
\itemize{
  \item \eqn{Pr(AA) = Pr(A)^2}
  \item \eqn{Pr(AB) = 2 * Pr(A) * Pr(A)}
  \item \eqn{Pr(BB) = Pr(B)^2}
}
}

\value{

\code{gpLong2Wide} returns a matrix with number of rows equal to number
of individuals and number of columns equal to number of possible
genotypes.

\code{hwp} returns a vector with Hardy-Weinberg genotype probabilities.

}

\author{Gregor Gorjanc}

\seealso{
  \code{\link{gpi}},
  \code{\link[genetics]{genotype}},
  \code{\link[genetics]{expectedGenotypes}}
}

\examples{

  if(require(genetics)) {
    gen <- genotype(c("A/A", "A/B"))
    hwp(x=gen)
    hwp(x=gen, trim=FALSE)
  }
}

\keyword{misc}

%--------------------------------------------------------------------------
% gpi.Rd ends here

% model.matrix.Rd
%--------------------------------------------------------------------------
% What: Model matrix for individuals with and without records
% $Id: model.matrix.Rd 1163 2007-04-03 13:58:58Z ggorjan $
% Time-stamp: <2007-04-03 01:42:24 ggorjan>
%--------------------------------------------------------------------------

\name{model.matrix.Pedigree}

\alias{model.matrix.Pedigree}

\title{Model matrix for individuals with and without records}

\description{

\code{model.matrix} for pedigree creates design matrix (\eqn{Z}) for
individuals with and without records. Used mainly for educational
purposes.

}

\usage{

\method{model.matrix}{Pedigree}(object, y, id, left=TRUE, names=TRUE,
                                \ldots)
}

\arguments{
  \item{object}{Pedigree}
  \item{names}{logical, should returned matrix have row/colnames; this
    can be used to get leaner matrix}
  \item{y}{numeric, vector of (phenotypic) records}
  \item{id}{vector of subjects for \code{y}}
  \item{left}{logical, bind columns of individuals without records to
    left (\code{left=TRUE}) or right (\code{left=FALSE}) side of
    \eqn{Z}}
  \item{\ldots}{arguments passed to \code{\link{model.matrix}}}
}

\value{A model matrix of \eqn{n * q} dimension, where \eqn{n} is number
  of records in \code{y} and \eqn{q} is number of subjects in the
  pedigree}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}, \code{\link{relationshipAdditive}},
\code{\link{inverseAdditive}} and \code{\link{model.matrix}}}

\examples{
  data(Mrode3.1)
  (x <- Pedigree(x=Mrode3.1, subject="calf", ascendant=c("sire", "dam"),
                 ascendantSex=c("Male", "Female"), sex="sex"))
  model.matrix(object=x, y=x$pwg, id=x$calf)
}

\keyword{models}

%--------------------------------------------------------------------------
% model.matrix.Rd ends here

% generation.Rd
%--------------------------------------------------------------------------
% What: Calculate generation value man page
% $Id: generation.Rd 1197 2007-04-06 12:03:00Z ggorjan $
% Time-stamp: <2007-04-19 02:42:07 ggorjan>
%--------------------------------------------------------------------------

\name{generation}

\alias{generation}
\alias{generation<-}

\title{Calculate generation value}

\description{

\code{generation} calculates generation value of individuals in given
pedigree. \code{generation<-} provides a way to properly add generation
information into the pedigree.

}

\usage{
generation(x, start=1, generationOrder=NULL)
generation(x, generationOrder=NULL, col=NULL) <- value
}

\arguments{
  \item{x}{pedigree object}
  \item{start}{first generation value}
  \item{generationOrder}{character, should be generation values
    "increasing" or "decreasing" through generations, see details}
  \item{col}{character, column name in \code{x} for generation}
  \item{value}{generation values for individuals in the pedigree}
}

\details{

Generation value for founders is set to value \code{start}, which is by
default 1, while other individuals get it according to:

\deqn{G_s = max(G_{1a} + G_{2a} + ... G_{na}) + 1}

where G represents generation value for s - individual, a - ascendant
e.g. father and mother, where n=2. N might be higher if there are
multiple ascendants i.e. this function can also handle pedigrees with
higher order ascendants e.g. grandfather.

\code{generationOrder} can be used to define "increasing" or
"decreasing" order of generation values. If this argument is
\code{NULL}, which is default, then this information is taken from
the pedigree - see \code{\link{Pedigree}} for more on this issue.

\code{col} provides a way to name or possibly also rename generation
column with user specified value, say "generazione" in Italian. When
\code{col=NULL}, which is default, "generation" is used.

}

\value{A vector of generation values (integers)}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  # Nonoverlapping pedigree
  ped <- generatePedigree(nId=5, nGeneration=4, nFather=1, nMother=2)
  ped$generation1 <- generation(ped)
  ped

  # Overlapping Pedigree
  ped <- data.frame(     id=c(1, 2, 3, 4, 5, 6, 7),
                     father=c(0, 0, 2, 2, 2, 4, 4),
                     mother=c(0, 0, 1, 0, 3, 3, 5),
                    dtBirth=c(2, 1, 3, 4, 5, 6, 7))
  ped <- Pedigree(ped, unknown=0, dtBirth="dtBirth")
  generation(ped) <- generation(ped)

  # Overlapping pedigree + one individual (4) comes late in pedigree and
  # has no ascendants
  ped <- data.frame(     id=c(1, 2, 3, 4, 5, 6, 7),
                     father=c(0, 0, 2, 0, 2, 4, 4),
                     mother=c(0, 0, 1, 0, 3, 3, 5),
                    dtBirth=c(2, 1, 3, 2, 5, 6, 7))
  ped <- Pedigree(ped, unknown=0, dtBirth="dtBirth")
  generation(ped)
  generation(ped, generationOrder="decreasing",
             col="generazione") <- generation(ped, generationOrder="decreasing")
}

\keyword{manip}
\keyword{misc}

%--------------------------------------------------------------------------
% generation.Rd ends here

% datasets.Rd
%--------------------------------------------------------------------------
% What: Pedigree and data examples
% $Id$
% Time-stamp: <2007-04-19 02:36:38 ggorjan>
%--------------------------------------------------------------------------

\name{Mrode}

\alias{Falconer}
\alias{Falconer5.1}
\alias{Mrode}
\alias{Mrode2.1}
\alias{Mrode3.1}

\docType{data}

\title{Pedigree and data examples}

\description{Various pedigree and data examples}

\usage{
data(Falconer5.1)
data(Mrode2.1)
data(Mrode3.1)
}

\format{
  \code{Falconer5.1} is a rather complex (inbreed) pedigree example from
  book by Falconer and Mackay (1996) - page 84 with 18 individuals and
  following columns:

  \describe{
    \item{sub}{individual}
    \item{fat}{father}
    \item{mot}{mother}
  }

  \code{Mrode2.1} is an extended pedigree example from book by
  Mrode (2005) - page 27 with 6 individuals and following columns:

  \describe{
    \item{sub}{individual}
    \item{fat}{father}
    \item{mot}{mother}
    \item{fam}{family}
    \item{sex}{sex}
    \item{gen}{generation}
    \item{dtB}{date of birth}
  }

  \code{Mrode3.1} is a pedigree and data example from book by
  Mrode (2005) - page 43: it shows a beef breeding scenario with 8
  individuals (animals), where 5 of them have phenotypic records
  (pre-weaning gain) and 3 three of them are without records and link
  others through the pedigree:

  \describe{
    \item{calf}{calf}
    \item{sex}{sex of a calf}
    \item{sire}{father of a calf}
    \item{dam}{mother of a calf}
    \item{pwg}{pre-weaning gain of a calf in kg}
  }
}

\references{

Falconer, D. S. and Mackay, T. F. C. (1996) Introduction to Quantitative
Genetics. 4th edition. Longman, Essex, U.K.
\url{http://www.amazon.com/gp/product/0582243025}

Mrode, R. A. (2005) Linear models for the prediction of animal breeding
values. 2nd edition. CAB International. ISBN 0-85199-000-2
\url{http://www.amazon.com/gp/product/0851990002}

}

\examples{
  data(Falconer5.1)
  Pedigree(x=Falconer5.1, subject="sub", ascendant=c("fat", "mot"))

  data(Mrode2.1)
  Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
  Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
           ascendantSex=c("M", "F"), family="fam", sex="sex",
           generation="gen", dtBirth="dtB")

  data(Mrode3.1)
  Pedigree(x=Mrode3.1, subject="calf", ascendant=c("sire", "dam"),
           ascendantSex=c("Male", "Female"), sex="sex")

}

\keyword{datasets}

%--------------------------------------------------------------------------
% datasets.Rd ends here

% nIndividual.Rd
%--------------------------------------------------------------------------
% What: Number of individuals in a pedigree
% $Id: nIndividual.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2007-04-19 02:40:49 ggorjan>
%--------------------------------------------------------------------------

\name{nIndividual}

\alias{nIndividual}

\title{Number of individuals in a pedigree}

\description{

\code{nIndividual} returns number of individuals (individuals and/or
ascendants) in a pedigree object.

}

\usage{nIndividual(x, col=NULL, extend=TRUE, drop=TRUE)}

\arguments{
  \item{x}{pedigree}
  \item{col}{character, which id column should be the source: "id"
    (default) or particular ascendant i.e. "father" and "mother"}
  \item{extend}{logical, extend pedigree}
  \item{drop}{logical, drop unused levels in case factors are used}
}

\details{
  FIXME - this will change a lot!!!!
  There is always one additional level in levels in case factors are
  used to represent individuals in a pedigree as described in
  \code{\link{Pedigree}}. However, \code{nlevels.Pedigree} prints out
  the number of levels actually used to represent individuals i.e. level
  unknown is not included into the result.
}

\author{Gregor Gorjanc}

\seealso{\code{summary.Pedigree}, \code{extend}}

\examples{
  # Deafult example
  ped <- generatePedigree(5)
  nIndividual(ped)

  # Other id columns
  nIndividual(ped, col="father")
  nIndividual(ped, col="mother")

  # Remove individuals with unknown fathers - FIXME
  # ped <- ped[!is.na(ped, col="father"), ]
  # nIndividual(ped)
  # nIndividual(ped, extend=FALSE)
}

\keyword{misc}

%--------------------------------------------------------------------------
% nIndividual.Rd ends here

% prune.Rd
%--------------------------------------------------------------------------
% What: Prune pedigree - help
% $Id$
% Time-stamp: <2007-09-07 00:36:24 ggorjan>
%--------------------------------------------------------------------------

\name{prune}

\alias{prune}

\concept{trim}
\concept{prune}

\title{Prune pedigree}

\description{

\code{prune} removes noninformative individuals from a
pedigree. This process is usually called trimming or
pruning. Individuals are removed if they do not provide any ancestral
ties between other individuals. It is possible to add some additional
criteria. See details.

}

\usage{

prune(x, id, father, mother, unknown=NA, testAdd=NULL, verbose=FALSE)

}

\arguments{
  \item{x}{data.frame, pedigree data}
  \item{id}{character, individuals's identification column name}
  \item{father}{character, father's identification column name}
  \item{mother}{character, mother's identification column name}
  \item{unknown}{value(s) used for representing unknown parent in
    \code{x}}
  \item{testAdd}{logical, additional criteria; see details}
  \item{verbose}{logical, print some more info}
}

\details{

NOTE: this function does not yet work with Pedigree class.

There are always some individuals in the pedigree that jut out. Usually
this are older individuals without known ancestors, founders. If such
individuals have only one (first) descendant and no phenotype/genotype
data, then they do not give us any additional information and can be
safely removed from the pedigree. This process resembles cutting/pruning
the branches of a tree.

By default \code{prune} iteratively removes individuals from the
pedigree (from top to bottom) if:
\itemize{
  \item they are founders, have both ancestors i.e. father and mother
    unknown and
  \item have only one or no (first) descendants i.e. children
}

If there is a need to take into account availability of say
phenotype/genotype data or any other information, argument
\code{testAdd} can be used. Value of this argument must be logical and
with length equal to number of rows in the pedigree. The easiest way to
achieve this is to \code{\link{merge}} any data to the pedigree and then
to perform a test, which will return logical values. Note that value of
\code{TRUE} in \code{testAdd} means to remove an individual - this
function is removing individuals! To keep an individual without known
parents and one or no children, value of \code{testAdd} must be
\code{FALSE} for that particular individual. Take a look at the
examples.

There are various conventions on representing unknown/missing ancestors,
say 0. \R's default is to use \code{NA}. If other values than \code{NA}
are present, argument \code{unknown} can be used to convert
unknown/missing values to \code{NA}.

It is assumed that pedigree is in extended form i.e. that each father
and mother has each own record as an individual. Otherwise error is
returned with information on which parents do not appear as
individuals.

\code{prune} does not only remove lines for pruned individuals
but also removes them from \code{father} and \code{mother} columns.

Pruning is done from top to bottom of the pedigree i.e. from
oldest individuals towards younger ones. Take for example the following
part of the pedigree in example section:

\preformatted{
     0   7
     |   |
     -----
       |
  10   8
   |   |
   -----
     |
     9
}

Individual 7 is not removed since it has two (first) descendants i.e. 8
and 5 (not shown here). Consecutively, individuals 8 and 9 are also not
removed from the pedigree. Individual 10 is removed, since it has only
one descendant. Why should individuals 8 and 9 and therefore also 7 stay
in the pedigree? Current behaviour is reasonable if pedigree is built in
such a way that first individuals with some phenotype or genotype data
are gathered and then their pedigree is being built. Say, individual 9
has pehnotype/genotype data and its pedigree is build and there is
therefore no need to remove such an individual. However, if pedigree is
not built in such a way, then \code{prunPedigree} function can not prune
all noninformative individuals. Argument \code{testAdd} can not help
with this issue, since basic tests (founder and one or no first
descendants) and \code{testAdd} are combined with
\code{\link[base:Logic]{&}}.

}

\value{

\code{prune} returns a data.frame with possibly fewer
individuals. Read also the details.

}

\seealso{
  \code{\link{Pedigree}}
}

\author{Gregor Gorjanc}

\examples{

  ## Pedigree example
  x <- data.frame(oseba=c(1,  9, 11, 2, 3, 10, 8, 12, 13,  4, 5, 6, 7, 14, 15, 16, 17),
                    oce=c(2, 10, 12, 5, 5,  0, 7,  0,  0,  0, 7, 0, 0,  0,  0,  0,  0),
                   mama=c(3,  8, 13, 0, 4,  0, 0,  0,  0, 14, 6, 0, 0, 15, 16, 17,  0),
                   spol=c(2,  2,  2, 1, 2,  1, 2,  1,  2,  2, 1, 2, 1,  1,  1,  1,  1),
             generacija=c(1,  1,  1, 2, 2,  2, 2,  2,  2,  3, 3, 4, 4,  5,  6,  7,  8),
                   last=c(2, NA,  8, 4, 1,  6,NA, NA, NA, NA,NA,NA,NA, NA, NA, NA, NA))

  ## Default case
  prune(x=x, id="oseba", father="oce", mother="mama", unknown=0)

  ## Use of additional test i.e. do not remove individual if it has
  ## known value for "last"
  prune(x=x, id="oseba", father="oce", mother="mama", unknown=0,
                testAdd=is.na(x$last))

  ## Use of other data
  y <- data.frame(oseba=c( 11,  15, 16),
                  last2=c(8.5, 7.5, NA))

  x <- merge(x=x, y=y, all.x=TRUE)
  prune(x=x, id="oseba", father="oce", mother="mama", unknown=0,
                testAdd=is.na(x$last2))

}

\keyword{manip}

%--------------------------------------------------------------------------
% prune.Rd ends here

% summary.pedigree.Rd
%--------------------------------------------------------------------------
% What: Extend pedigree man page
% $Id: summary.pedigree.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2006-09-30 01:32:11 ggorjan>
%--------------------------------------------------------------------------

\name{summary.Pedigree}

\alias{summary.Pedigree}

\title{Pedigree summary}

\description{\code{summary.Pedigree} reports TODO.
}

\usage{\method{summary}{Pedigree}(object, \ldots)}

\arguments{
  \item{object}{pedigree object}
  \item{\ldots}{additional arguments for other methods (not used)}
}

\details{
  TODO.
}

\value{
  TODO.
}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ped <- generatePedigree(nId=5)
  summary(ped)
}

\keyword{manip}
\keyword{misc}

%--------------------------------------------------------------------------
% summary.pedigree.Rd ends here

% geneContribution.Rd
%--------------------------------------------------------------------------
% What: Gene contribution or proportion of genes in pedigree by
%       individual man page
% $Id: prop.pedigree.Rd 895 2006-06-16 14:28:51Z dnadave $
% Time-stamp: <2007-04-19 02:37:24 ggorjan>
%--------------------------------------------------------------------------

\name{geneContribution}

\alias{geneContribution}

\title{Gene contribution or proportion of genes in pedigree by individual}

\description{\code{geneContribution} calculates gene contribution
  as proportion of genes in pedigree by individual with higher number of
  descendants will have higher values.
}

\usage{geneContribution(x, relative=TRUE)}

\arguments{
  \item{x}{pedigree}
  \item{relative}{logical, should results be presented relative to
    number of individuals in the pedigree}
}

\value{

Gene contribution values i.e. higher the values higher the contribution
of genes by particular individual in the pedigree. When
\code{relative=FALSE}, values represent number of individuals (in
conceptually additive manner i.e. 0.5 + 0.75 = 1.25 individual) in the
pedigree that carry genes of a particular individual. With
\code{relative=TRUE}, values represent the same result as ratios to all
individuals in the pedigree. Value 0 indicates that individual did not
pass its genes to next generations.

}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ped <- generatePedigree(nId=5, nGeneration=4, nFather=1, nMother=2)
  geneContribution(ped)
  geneContribution(ped, relative=FALSE)
  ## geneContribution(ped[5:15, ]) ## needs [ method

  ## More than one father example
  ped <- data.frame(     id=c(1, 2, 3, 4, 5, 6, 7),
                    father1=c(0, 0, 0, 2, 1, 1, 2),
                    father2=c(0, 0, 0, 0, 0, 2, 0),
                     mother=c(0, 0, 0, 0, 3, 3, 3),
                    generat=c(1, 1, 1, 2, 2, 2, 2))
  ped <- Pedigree(ped, ascendant=c("father1", "father2", "mother"),
                  ascendantSex=c(1, 1, 2), ascendantLevel=c(1, 1, 1),
                  unknown=0, generation="generat")
  geneContribution(ped)
}

\keyword{array}
\keyword{misc}

%--------------------------------------------------------------------------
% geneContribution.Rd ends here

% gpi.Rd
%--------------------------------------------------------------------------
% What: Genotype probability index
% $Id: gpi.Rd 1175 2007-04-03 14:09:20Z ggorjan $
% Time-stamp: <2007-09-13 03:18:45 ggorjan>
%--------------------------------------------------------------------------

\name{gpi}

\alias{gpi}

\concept{segregation}
\concept{genotype probability}
\concept{information}

\title{Genotype probability index}

\description{

\code{gpi} calculates Genotype Probability Index (GPI), which indicates
the information content of genotype probabilities derived from
segregation analysis.

}

\usage{
  gpi(gp, hwp)
}

\arguments{
  \item{gp}{numeric vector or matrix, individual genotype probabilities}
  \item{hwp}{numeric vector or matrix, Hard-Weinberg genotype
    probabilities}
}

\details{

Genotype Probability Index (GPI; Kinghorn, 1997; Percy and Kinghorn,
2005) indicates information that is contained in multi-allele genotype
probabilities for diploids derived from segregation analysis, say
Thallman et. al (2001a, 2001b). GPI can be used as one of the criteria
to help identify which ungenotyped individuals or loci should be
genotyped in order to maximise the benefit of genotyping in the
population (e.g. Kinghorn, 1999).

\code{gp} and \code{hwp} arguments accept genotype probabilities for
multi-allele loci. If there are two alleles (1 and 2), you should pass
vector of probabilities for genotypes (11 and 12) i.e. one value for
heterozygotes (12 and 21) and always skipping last homozygote. With
three alleles this vector should hold probabilities for genotypes (11,
12, 13, 22, 23) as also shown bellow and in examples. \code{\link{hwp}}
and \code{\link{gpLong2Wide}} functions can be used to ease the setup
for \code{gp} and \code{hwp} arguments.

\preformatted{
     2 alleles: 1 and 2
     11 12
     --> no. dimensions = 2

     3 alleles: 1, 2, and 3
     11 12 13
        22 23
     --> no. dimensions = 5

     ...

     5 alleles: 1, 2, 3, 4, and 5
     11 12 13 14 15
        22 23 24 25
           33 34 35
              44 45
     --> no. dimensions = 14
}

In general, number of dimensions (\eqn{k}) for \eqn{n} alleles is equal
to:

\deqn{k = (n * (n + 1) / 2) - 1.}

If you have genotype probabilities for more than one individual, you can
pass them to \code{gp} in a matrix form, where each row represents
genotype probabilities of an individual. In case of passing matrix to
\code{gp}, \code{hwp} can still accept a vector of Hardy-Weinberg
genotype probabilities, which will be used for all individuals due to
recycling. If \code{hwp} also gets a matrix, then it must be of the same
dimension as that one passed to \code{gp}.

}

\value{Vector of \eqn{N} genotype probability indices, where \eqn{N} is
  number of individuals}

\references{

Kinghorn, B. P. (1997) An index of information content for genotype
probabilities derived from segregation analysis. \emph{Genetics}
\bold{145}(2):479-483
\url{http://www.genetics.org/cgi/content/abstract/145/2/479}

Kinghorn, B. P. (1999) Use of segregation analysis to reduce genotyping
costs. \emph{Journal of Animal Breeding and Genetics}
\bold{116}(3):175-180
\url{http://dx.doi.org/10.1046/j.1439-0388.1999.00192.x}

Percy, A. and Kinghorn, B. P. (2005) A genotype probability index for
multiple alleles and haplotypes. \emph{Journal of Animal Breeding and
Genetics} \bold{122}(6):387-392
\url{http://dx.doi.org/10.1111/j.1439-0388.2005.00553.x}

Thallman, R. M. and Bennet, G. L. and Keele, J. W. and Kappes,
S. M. (2001a) Efficient computation of genotype probabilities for loci
with many alleles: I. Allelic peeling. \emph{Journal of Animal
Science} \bold{79}(1):26-33
\url{http://jas.fass.org/cgi/reprint/79/1/34}

Thallman, R. M. and Bennet, G. L. and Keele, J. W. and Kappes,
S. M. (2001b) Efficient computation of genotype probabilities for loci
with many alleles: II. Iterative method for large, complex
pedigrees. \emph{Journal of Animal Science}
\bold{79}(1):34-44
\url{http://jas.fass.org/cgi/reprint/79/1/34}

}

\author{Gregor Gorjanc R code, documentation, wrapping into a package;
  Andrew Percy and Brian P. Kinghorn Fortran code}

\seealso{
  \code{\link{hwp}} and
  \code{\link{gpLong2Wide}}
}

\examples{
  ## --- Example 1 from Percy and Kinghorn (2005) ---
  ## No. alleles: 2
  ## No. individuals: 1
  ## Individual genotype probabilities:
  ##   Pr(11, 12, 22) = (.1, .5, .4)
  ##
  ## Hardy-Weinberg probabilities:
  ##   Pr(1, 2)   = (.75, .25)
  ##   Pr(11, 12,   (.75^2, 2*.75*.25,
  ##           22) =             .25^2)
  ##               = (.5625, .3750,
  ##                         .0625)

  gp <- c(.1, .5)
  hwp <- c(.5625, .3750)
  gpi(gp=gp, hwp=hwp)

  ## --- Example 1 from Percy and Kinghorn (2005) extended ---
  ## No. alleles: 2
  ## No. individuals: 2
  ## Individual genotype probabilities:
  ##   Pr_1(11, 12, 22) = (.1, .5, .4)
  ##   Pr_2(11, 12, 22) = (.2, .5, .3)

  (gp <- matrix(c(.1, .5, .2, .5), nrow=2, ncol=2, byrow=TRUE))
  gpi(gp=gp, hwp=hwp)

  ## --- Example 2 from Percy and Kinghorn (2005) ---
  ## No. alleles: 3
  ## No. individuals: 1
  ## Individual genotype probabilities:
  ##   Pr(11, 12, 13,   (.1, .5, .0,
  ##          22, 23  =      .4, .0,
  ##              33)            .0)
  ##
  ## Hardy-Weinberg probabilities:
  ##   Pr(1, 2, 3)    = (.75, .25, .0)
  ##   Pr(11, 12, 13,   (.75^2, 2*.75*.25, .0,
  ##          22, 23, =            0.25^2, .0,
  ##              33)                      .0)
  ##                  = (.5625, .3750, .0
  ##                            .0625, .0,
  ##                                   .0)

  gp <- c(.1, .5, .0, .4, .0)
  hwp <- c(.5625, .3750, .0, .0625, .0)
  gpi(gp=gp, hwp=hwp)

  ## --- Example 3 from Percy and Kinghorn (2005) ---
  ## No. alleles: 5
  ## No. individuals: 1
  ## Hardy-Weinberg probabilities:
  ##   Pr(1, 2, 3, 4, 5)   = (.2, .2, .2, .2, .2)
  ##   Pr(11, 12, 13, ...) = (Pr(1)^2, 2*Pr(1)+Pr(2), 2*Pr(1)*Pr(3), ...)
  ##
  ## Individual genotype probabilities:
  ##   Pr(11, 12, 13, ...) = gp / 2
  ##   Pr(12) = Pr(12) + .5

  (hwp <- rep(.2, times=5) \%*\% t(rep(.2, times=5)))
  hwp <- c(hwp[upper.tri(hwp, diag=TRUE)])
  (hwp <- hwp[1:(length(hwp) - 1)])
  gp <- hwp / 2
  gp[2] <- gp[2] + .5
  gp

  gpi(gp=gp, hwp=hwp)

  ## --- Simulate gp for n alleles and i individuals ---
  n <- 3
  i <- 10

  kAll <- (n*(n+1)/2) # without -1 here!
  k <- kAll - 1
  if(require("gtools")) {
    gp <- rdirichlet(n=i, alpha=rep(x=1, times=kAll))[, 1:k]
    hwp <- as.vector(rdirichlet(n=1, alpha=rep(x=1, times=kAll)))[1:k]
    gpi(gp=gp, hwp=hwp)
  }
}

\keyword{misc}

%--------------------------------------------------------------------------
% gpi.Rd ends here

% extend.Rd
%--------------------------------------------------------------------------
% What: Extend pedigree man page
% $Id: extend.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2007-04-19 02:37:55 ggorjan>
%--------------------------------------------------------------------------

\name{extend}

\alias{extend}

\title{Extend pedigree}

\description{\code{extend} finds ascendants, which do not appear as
  individuals in pedigree and assigns them as individuals with unknown
  ascendants in extended pedigree.
}

\usage{extend(x, ascendant=NULL, col=NULL, top=TRUE)}

\arguments{
  \item{x}{pedigree object}
  \item{ascendant}{character, column names of ascendant(s), see details}
  \item{col}{character, column name(s) of attribute(s), see details}
  \item{top}{logical, add ascendants as individuals on the top or
    bottom of the pedigree}
}

\details{

Argument \code{ascendant} can be used to define, which ascendants will
be extended. If \code{ascendant=NULL}, which is the default, all
ascendant columns in the pedigree are used. The same approach is used
with other pedigree attributes such as sex, generation, etc. with
argument \code{col}. Use \code{col=NA}, if none of the pedigree
attributes should be extended.

Sex of \dQuote{new} individuals is infered from attribute
\code{ascendantSex} as used in \code{Pedigree} function. Generation of
\dQuote{new} individuals is infered as minimal
(\code{generationOrder="increasing"}) or maximal
(\code{generationOrder="decreasing"}) generation value in descendants -
1. See \code{\link{Pedigree}} on this issue. Family values are extended
with means of \code{\link{family}}.

}

\value{

Extended pedigree, where all ascendants also appear as individuals with
unknown ascendants and infered other attributes such as sex, generation,
etc. if this attributes are in the pedigree.

}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}, \code{\link{family}},
  geneticGroups???}

\examples{
  # --- Toy example ---
  ped <- generatePedigree(nId=5, nGeneration=4, nFather=1, nMother=2)
  ped <- ped[10:20,]
  ped[5, "father"] <- NA # to test robustnes of extend on NA
  extend(ped)
  extend(ped, top=FALSE)

  ## Extend only ascendant and their generation
  extend(ped, col="generation")
  extend(ped, col=c("generation", "sex"))

  # --- Bigger example ---
  ped <- generatePedigree(nId=1000, nGeneration=10, nFather=100,
                          nMother=500)
  nrow(ped)
  # Now keep some random individuals
  ped <- ped[unique(sort(round(runif(n=nrow(ped)/2, min=1,
                                     max=nrow(ped))))), ]
  nrow(ped)
  nrow(extend(ped))
}

\keyword{manip}
\keyword{misc}

%--------------------------------------------------------------------------
% extend.Rd ends here

% undocumented.Rd
%--------------------------------------------------------------------------
% What: Undocumented functions
% $Id: undocumented.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2006-09-30 01:31:29 ggorjan>
%--------------------------------------------------------------------------

\name{undocumented}

\alias{undocumented}

\title{Undocumented functions}

\description{

These functions are undocumented. Some are internal and not intended for
direct use. Some are not yet ready for end users. Others simply haven't
been documented yet.

}

\keyword{misc}

%--------------------------------------------------------------------------
% undocumented.Rd ends here

% relationshipAdditive.Rd
%--------------------------------------------------------------------------
% What: Additive relationship matrix (A) man page
% $Id: relationshipAdditive.Rd 1167 2007-04-03 14:02:23Z ggorjan $
% Time-stamp: <2007-04-01 23:12:01 ggorjan>
%--------------------------------------------------------------------------

\name{relationshipAdditive}

\alias{relationshipAdditive}
\alias{inverseAdditive}
\alias{kinship}

\concept{relationship}
\concept{relatedness}
\concept{genetic covariance}
\concept{coefficient of coancestry}
\concept{coefficient of consanguinity}
\concept{coefficient de parente}

\title{Additive relationship matrix and its inverse}

\description{

\code{relationshipAdditive} creates additive relationship matrix, while
\code{inverseAdditive} creates its inverse directly from a
pedigree. \code{kinship} is another definition of relationship and is
equal to half of additive relationship.

}

\usage{

relationshipAdditive(x, sort=TRUE, names=TRUE, \ldots)
inverseAdditive(x, sort=TRUE, names=TRUE, \ldots)
kinship(x, sort=TRUE, names=TRUE, \ldots)

}

\arguments{
  \item{x}{Pedigree}
  \item{sort}{logical, for the computation the pedigree needs to be
    sorted, but results are sorted back to original sorting (sort=TRUE)
    or not (sort=FALSE)}
  \item{names}{logical, should returned matrix have row/colnames; this
    can be used to get leaner matrix}
  \item{\ldots}{arguments for other methods}
}

\details{

Additive or numerator relationship matrix is symetric and contains
\eqn{1 + F_i} on diagonal, where \eqn{F_i} is an inbreeding coefficients
(see \code{\link{inbreeding}}) for subject \eqn{i}. Off-diagonal
elements represent numerator or relationship coefficient bewteen
subjects \eqn{i} and \eqn{j} as defined by Wright (1922). Henderson
(1976) showed a way to setup inverse of relationship matrix
directly. Mrode (2005) has a very nice introduction to these concepts.

Take care with \code{sort=FALSE, names=FALSE}. It is your own
responsibility to assure proper handling in this case.

}

\value{A matrix of \eqn{n * n} dimension, where \eqn{n} is number of
subjects in \code{x}}

\references{

Henderson, C. R. (1976) A simple method for computing the inverse of a
numerator relationship matrix used in prediction of breeding
values. \emph{Biometrics} \bold{32}(1):69-83

Mrode, R. A. (2005) Linear models for the prediction of animal breeding
values. 2nd edition. CAB International. ISBN 0-85199-000-2
\url{http://www.amazon.com/gp/product/0851990002}

Wright, S. (1922) Coefficients of inbreeding and relationship.
\emph{American Naturalist} 56:330-338

}

\author{Gregor Gorjanc and Dave A. Henderson}

\seealso{\code{\link{Pedigree}}, \code{\link{inbreeding}} and
\code{\link{geneFlowT}}}

\examples{
  data(Mrode2.1)
  Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
  x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                   ascendantSex=c("M", "F"), family="fam", sex="sex",
                   generation="gen", dtBirth="dtB")

  (A <- relationshipAdditive(x2.1))
  fractions(A)
  solve(A)
  inverseAdditive(x2.1)
  relationshipAdditive(x2.1[3:6, ])
  
  ## Compare the speed
  ped <- generatePedigree(nId=10, nGeneration=3, nFather=1, nMother=2)
  system.time(solve(relationshipAdditive(ped)))
  system.time(inverseAdditive(ped))
}

\keyword{array}
\keyword{misc}

%--------------------------------------------------------------------------
% relationshipAdditive.Rd ends here

% pedigree.Rd
%--------------------------------------------------------------------------
% What: Pedigree class and methods man page
% $Id: pedigree.Rd 1175 2007-04-03 14:09:20Z ggorjan $
% Time-stamp: <2007-04-01 23:06:57 ggorjan>
%--------------------------------------------------------------------------

\name{Pedigree}

\alias{Pedigree}

\alias{is.Pedigree}

\alias{as.Pedigree}
\alias{as.Pedigree.Pedigree}
\alias{as.Pedigree.data.frame}
\alias{as.Pedigree.matrix}

% \alias{"[.Pedigree"}

\alias{as.integer.Pedigree}
\alias{as.factor.Pedigree}
\alias{as.character.Pedigree}

\concept{genealogy}

\title{Pedigree}

\description{\code{Pedigree} function creates a pedigree object}

\usage{

Pedigree(x, subject="id", ascendant=c("father", "mother"),
  ascendantSex=c(1, 2), ascendantLevel=c(1, 1), unknown=NA, sex=NA,
  dtBirth=NA, generation=NA, family=NA, generationOrder="increasing",
  check=TRUE, sort=FALSE, extend=FALSE, drop=TRUE, codes=FALSE)

}

\arguments{
  \item{x}{data.frame or matrix}
  \item{subject}{character, column name in \code{x} for subjects}
  \item{ascendant}{character, column name(s) in \code{x} for ascendants}
  \item{family}{character, column name in \code{x} for family}
  \item{ascendantSex}{integer orcharacter, sex of ascendant(s); see details}
  \item{ascendantLevel}{integer, generation level of ascendant(s); see
    details}
  \item{unknown}{vector or list, uknown representation of identification
    and other data in the pedigree; see details}
  \item{sex}{character, column name in \code{x} for sex}
  \item{dtBirth}{character, column name in \code{x} for date of birth}
  \item{generation}{character, column name in \code{x} for generation}
  \item{generationOrder}{character, generation value is "increasing" or
    "decreasing" through generations; see details}
  \item{check}{logical, check for common errors}
  \item{sort}{logical, sort pedigree}
  \item{extend}{logical, extend pedigree}
  \item{drop}{logical, drop unused levels if factors are used}
  \item{codes}{logical, code individuals into integers}
}

\details{

FIXME: study geneSet class

Pedigree can be one source of information on genetic relationship
between relatives. Take for example the following pedigree:

  \preformatted{
  paternal    paternal     maternal    maternal
  grandfather grandmother  grandfather grandmother
      |           |            |           |
      -------------            -------------
            |                        |
          father                   mother
            |                        |
            -------------------------
                        |
                     subject
                   }

  This information can be stored in a data.frame as

  \tabular{lll}{
    mother  \tab maternal grandfather \tab maternal grandmother \cr
    father  \tab paternal grandfather \tab paternal grandmother \cr
    subject \tab father               \tab mother
  }

There is considerable variability in terminology between as well as
within various fields of genetics. We use the following terms throughout
the help and code: individual (any individual in a pedigree), subject
(individual whose pedigree is given i.e. individuals in the first column
in upper data.frame), ascendant and descendant. Additionally, family,
sex, dtBirth and generation are used for additional data in the
pedigree. Their meaning should be clear. For these, argument \code{col}
is usually used in function calls.

\code{\link{family}} TODO

\code{ascendantSex} can be used to define sex of ascendant(s); for
example c("Male", "Female") or c("M", "F") or even c(1, 2) for father
and mother or c(2, 1, 1) for mother and two possible fathers or c(1, 1)
for father and maternal father etc. This data is needed only for the
structure of the class and defaults should be ok for the majority. But
you need to make sure that data defined here must be in accordance with
values in \code{sex} column.

\code{ascendantLevel} can be used to define generation level of
ascendant(s) in relation to a subject; for example c(1, 1) for father
and mother or c(1, 1, 1) for mother and two possible fathers or c(1, 2)
for father and maternal father etc. This data is needed only for the
structure of the class and defaults should be ok for the majority.

There is no need for \code{as.integer} TODO in arguments
\code{ascendantLevel} as this is done internally.

unknown TODO

% FIXME: check unknown here and in unknown.R
% When pedigree object is created, argument \code{unknown} can be used to
% specify which values in the source data i.e. pedigree represent unknown
% individuals as well as for family, sex, dtBirth and generation. By
% default \code{NA} is used. Argument \code{unknown} can be either vector
% (single value such as \code{0} or true vector such as c(0, 999,
% 1000000)) or a list. If it is not a list, it is assumed that
% \code{unknown} holds for all specified columns above. List can be used
% to specify different unknown values for each column such as
% \code{list(id=c("-", 0) family="no-name", sex=0, dtBirth=TODO,
% genereation=-1)}. If only some columns are specified as in
% \code{list(id="NA", sex=0)}, it is assumed that \code{NA} will suffice
% for the rest. All unknown values are changed to NA via
% \code{\link{unknownToNA.Pedigree}}. If this is not wanted,
% \code{\link{NAToUnknown.Pedigree}} can be used for reverse effect.

Sex TODO

Date of birth TODO

\code{generationOrder} defines in which order are
\code{\link{generation}} values: "increasing" if values increase from
ascendants to descendants and "decreasing" if values decrease from
ascendants to descendants.

\code{\link{check}}, \code{\link{sort}}, \code{\link{extend}}, and
\code{\link{codes}} are actions on the pedigree and have their own help
pages.

Individuals can be stored as either integer, numeric or factor TODO. In
any case all id columns must have the same class and this is
automatically checked. Argument \code{drop} can be used to drop unused
levels, if factors are used.

\code{as.Pedigree.*} FIXME
\code{as.*.Pedigree} FIXME

Object of Pedigree class is a data.frame with columns that can be
divided into core columns (subject, ascendant(s), sex, dtBirth and
generationTODO) and possibly other columns such as data on phenotype and
genotype and other subject attributes, for example factors and
covariates TODO. 

Additionally, the following attributes are set on pedigree:

\itemize{
  \item{.subject}{character, column name of subject identification in
    pedigree}
  \item{.ascendant}{character, column name(s) of ascendant(s)
    identification in pedigree}
  \item{.family}{character, column name of family identification in
    pedigree}
  \item{.ascendantSex}{integer, sex of ascendant(s)}
  \item{.ascendantLevel}{integer, generation level of ascendant(s)}
  \item{.sex}{character, column name of subject's sex}
  \item{.dtBirth}{character, column name of subject's date of birth}
  \item{.generation}{character, column name of subject's generation}
  \item{.generationOrder}{character, generation value is "increasing" or
    "decreasing" through generations}
  \item{.colClass}{character, storage class for id columns: "integer",
    "numeric" or "factor"}
  \item{.checked}{logical, is pedigree checked for common errors}
  \item{.sorted}{logical, is pedigree sorted; by TODO}
  \item{.extended}{logical, is pedigree extended}
  \item{.coded}{logical, is pedigree coded}
  \item{.unknown}{list, uknown representation for individual
    identification and other data in the pedigree; names of the list are
    c(".id", ".family", ".sex", ".dtBirth", ".generation")}
}

}

\value{Pedigree object as described in the details}

\author{Gregor Gorjanc}

\seealso{

% \code{\link{NAToUnknown.Pedigree}}

\code{\link{check}},
\code{\link{sort}}, and \code{\link{extend}} provide help on pedigree
utility functions. 

}

\examples{

data(Mrode2.1)
Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                 ascendantSex=c("M", "F"), family="fam", sex="sex",
                 generation="gen", dtBirth="dtB")

%   ## --- unknown usage ---
%   ped <- generatePedigree(2)
%   ped[2, 1] <- 11111
%   ped[3, 2] <- 999
%   ped[1, 3] <- 0
%   Pedigree(ped, unknown=c(0, 999))
%   Pedigree(ped, unknown=c(0, 999, 11111))
%   ## FIXME: we get recycling for unknown here, so this does not work -->
%   ##        how to fix this? --> also FIXME note in unknown.R

if (FALSE) {
  ## How to handle different pedigree types
  ## * multiple parents
  ped2 <- ped
  ped2$father1 <- ped$father
  ped2$father2 <- ped$father
  ped2$father <- NULL
  ped2 <- as.data.frame(ped2)
  str(Pedigree(ped2, ascendant=c("father1", "father2", "mother"),
               ascendantSex=c(1, 1, 2), ascendantLevel=c(1, 1, 1)))

  ## * different level of parents
  ped3 <- as.data.frame(ped)
  ped3$m.grandfather <- ped3$mother
  ped3$mother <- NULL
  str(Pedigree(ped3, ascendant=c("father", "m.grandfather"),
               ascendantSex=c(1, 1), ascendantLevel=c(1, 2)))
}

}

\keyword{manip}
\keyword{misc}

%--------------------------------------------------------------------------
% pedigree.Rd ends here

% inbreeding.Rd
%--------------------------------------------------------------------------
% What: Inbreeding coefficient (F) man page
% $Id: inbreeding.Rd 1172 2007-04-03 14:05:59Z ggorjan $
% Time-stamp: <2007-04-01 23:11:29 ggorjan>
%--------------------------------------------------------------------------

\name{inbreeding}

\alias{inbreeding}

\concept{consanguinity}

\title{Inbreeding coefficient}

\description{\code{inbreeding} calculates inbreeding coefficients of
  individuals in the pedigree}

\usage{inbreeding(x, method="meuwissen", sort=TRUE, names=TRUE, \ldots)}

\arguments{
  \item{x}{pedigree object}
  \item{method}{character, method of calculation "tabular",
    "meuwissen" or "sargolzaei", see details}
  \item{sort}{logical, for the computation the pedigree needs to be
    sorted, but results are sorted back to original sorting (sort=TRUE)
    or not (sort=FALSE)}
  \item{names}{logical, should returned vector have names; this
    can be used to get leaner returned object}
  \item{\ldots}{arguments for other methods}
}

\details{

Coefficient of inbreeding (\eqn{F}) represents probability that two
alleles on a loci are identical by descent (Wright, 1922; Falconer and
Mackay, 1996). Wright (1922) showed how \eqn{F} can be calculated but
his method of paths is not easy to wrap in a program. Calculation of
\eqn{F} can also be performed using tabular method for setting the
additive relationship matrix (Henderson, 1976), where \eqn{F_i = A_{ii}
- 1}. Meuwissen and Luo (1992) and VanRaden (1992) developed faster
algorithms for \eqn{F} calculation. Wiggans et al. (1995) additionally
explains method in VanRaden (1992). Sargolzaei et al. (2005) presented
yet another fast method.

Take care with \code{sort=FALSE, names=FALSE}. It is your own
responsibility to assure proper handling in this case.

}

\references{

Falconer, D. S. and Mackay, T. F. C. (1996) Introduction to Quantitative
Genetics. 4th edition. Longman, Essex, U.K.
\url{http://www.amazon.com/gp/product/0582243025}

Henderson, C. R. (1976) A simple method for computing the inverse of a
numerator relationship matrix used in prediction of breeding
values. \emph{Biometrics} \bold{32}(1):69-83

Meuwissen, T. H. E. and Luo, Z. (1992) Computing inbreeding coefficients
in large populations. \emph{Genetics Selection and Evolution}
\bold{24}:305-313

Sargolzaei, M. and Iwaisaki, H. and Colleau, J.-J. (2005) A fast
algorithm for computing inbreeding coefficients in large
populations. \emph{Journal of Animal Breeding and Genetics}
\bold{122}(5):325--331
\url{http://dx.doi.org/10.1111/j.1439-0388.2005.00538.x}

VanRaden, P. M. (1992) Accounting for inbreeding and crossbreeding in
genetic evaluation for large populations. \emph{Journal of Dairy
Science} 75(11):3136-3144
\url{http://jds.fass.org/cgi/content/abstract/75/11/3136}

Wiggans, G. R. and VanRaden, P. M. and Zuurbier, J. (1995) Calculation
and use of inbreeding coefficients for genetic evaluation of United
States dairy cattle. \emph{Journal of Dairy Science}
\bold{78}(7):1584-1590
\url{http://jds.fass.org/cgi/content/abstract/75/11/3136}

Wright, S. (1922) Coefficients of inbreeding and relationship.
\emph{American Naturalist} 56:330-338

}

\value{A vector of length \eqn{n} with inbreeding coefficients, where
\eqn{n} is number of subjects in \code{x}}

\author{Gregor Gorjanc and Dave A. Henderson}

\seealso{\code{\link{Pedigree}}, \code{\link{relationshipAdditive}},
  \code{\link{kinship}} and \code{\link{geneFlowT}}}

\examples{
  data(Mrode2.1)
  Mrode2.1$dtB <- as.Date(Mrode2.1$dtB)
  x2.1 <- Pedigree(x=Mrode2.1, subject="sub", ascendant=c("fat", "mot"),
                   ascendantSex=c("M", "F"), family="fam", sex="sex",
                   generation="gen", dtBirth="dtB")
  fractions(inbreeding(x=x2.1))

  ## Compare the speed
  ped <- generatePedigree(nId=25)
  system.time(inbreeding(x=ped))
  # system.time(inbreeding(x=ped, method="sargolzaei")) # not yet implemented
  system.time(inbreeding(x=ped, method="tabular"))
}

\keyword{array}
\keyword{misc}

%--------------------------------------------------------------------------
% inbreeding.Rd ends here

% removeIndividual.Rd
%--------------------------------------------------------------------------
% What: Remove individual from pedigree
% $Id: removeIndividual.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2007-04-19 02:36:13 ggorjan>
%--------------------------------------------------------------------------

\name{removeIndividual}

\alias{removeIndividual}

\title{Remove individual from pedigree}

\description{

\code{removeIndividual} provides utility for removing individuals from a
pedigree.

}

\usage{removeIndividual(x, individual, remove="all")}

\arguments{
  \item{x}{pedigree}
  \item{individual}{vector of individuals}
  \item{remove}{character, column names of id columns and/or "all", see
    details}
}

\details{

Individuals passed to argument \code{individual} will be removed from
the pedigree. If there is a pedigree with individual "id" and two
ascendants, say "father" and "mother", then one can pass any combination
of these three id columns or "all" for all of them in short to argument
\code{remove}. In case only "id" is passed to \code{remove}, individuals
will be removed from the pedigree, but not from ascendant id columns, which
might be a matter of interest only if specified individuals show up as
ascendants for some other individuals. In case you want to remove an
individual completely from the pedigree "all" must be used.

Individuals in id column are removed via removal of the whole record
from the pedigree. Individuals in ascendant id columns are only replaced by
\code{attr(x, "unknown")}.

If founder is removed, attribute extended status is changed to FALSE.

}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ped <- generatePedigree(3)
  summary(ped)
  removeIndividual(ped, individual=c(1, 3, 4), remove="father")
  removeIndividual(ped, individual=c(1, 3, 4), remove=c("mother", "father"))
  (ped <- removeIndividual(ped, individual=c(1, 3, 4), remove=c("all")))
  summary(ped)
}

\keyword{misc}

%--------------------------------------------------------------------------
% removeIndividual.Rd ends here

% family.Rd
%--------------------------------------------------------------------------
% What: Find families (lines) in the pedigree
% $Idn$
% Time-stamp: <2007-04-19 02:37:31 ggorjan>
%--------------------------------------------------------------------------

\name{family}

\alias{family}
\alias{family<-}

\concept{line}
\concept{lineage}

\title{Find families (lines) in the pedigree}

\description{

\code{family} classifies individuals in the pedigree to distinct
families or lines. Two individuals are members of one family if they
have at least one common ascendant. \code{family<-} provides mean to
properly add family information into the pedigree.

}

\usage{
family(x)
family(x, col=NULL) <- value
}

\arguments{
  \item{x}{pedigree object}
  \item{col}{character, column name in \code{x} for family}
  \item{value}{family values for individuals in the pedigree}
}

\details{

\code{col} provides a mean to name or possibly also rename family column
with user specified value, say "familia" in Spanish. When
\code{col=NULL}, which is default, "family" is used.

}

\value{A vector of family values (integers)}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ## Two families examples
  ped <- data.frame(    id=c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11),
                    father=c(0, 0, 0, 0, 0, 0, 5, 1, 3,  8,  7),
                    mother=c(0, 0, 0, 0, 0, 0, 6, 2, 4,  9, 10),
                generation=c(1, 1, 1, 1, 1, 1, 2, 2, 2,  3,  4))
  ped <- Pedigree(ped, unknown=0, generation="generation")
  family(ped)

  ## After break we get two families
  ped1 <- removeIndividual(ped, individual=11)
  family(ped1)

  ## Subsetting can also be used
  family(ped[1:10,])
  family(ped[7:10,])

  ## Pedigree need not be sorted in advance
  ped2 <- ped[sample(1:10), ]
  family(ped2)

  ## Assign family values to pedigree
  family(ped) <- family(ped)
  ped
  family(ped, col="familia") <- family(ped)
  ped
}

\keyword{misc}

%--------------------------------------------------------------------------
% family.Rd ends here

% sort.pedigree.Rd
%--------------------------------------------------------------------------
% What: Sort pedigree
% $Id: check.Rd 825 2006-04-30 16:35:58Z ggorjan $
% Time-stamp: <2007-03-07 00:15:26 ggorjan>
%--------------------------------------------------------------------------

\name{sort.Pedigree}

\alias{sort.Pedigree}

\title{Sort pedigree}

\description{Pedigree sort}

\usage{
\method{sort}{Pedigree}(x, decreasing=FALSE, na.last=TRUE, \ldots, by="default")
}

\arguments{
  \item{x}{pedigree, object to be sorted}
  \item{decreasing}{logical, sort order}
  \item{na.last}{logical, control treatment of \code{NA}s; check
    \code{\link{order}}}
  \item{\ldots}{arguments passed to \code{order}, see details}
  \item{by}{character, sort by "default", "pedigree", "generation", or
    "dtBirth" information, see details}
}

\details{

Sorting of the pedigree can be performed in different ways. Since
pedigree can contain date of birth, sorting by this would be the most
obvious way and it would be the most detailed sort. However, there might
be the case that date of birth is not available for some or all
individuals. Therefore, this function by default (when
\code{by="default"}) tries to figure out what would be the best way to
perform the sort. If date of birth is available for all individuals then
date of birth is used for sorting. If not, generation information is
used, but only if it is known for all individuals (it should be more or
less easy to figure out the generation for all individuals in the
pedigree CHECK). Again if not, sorting is done via information in
pedigree i.e. ascendants will precede descendants or vice versa. User
can always define it's own preference by argument \code{by}. When
\code{by="dtBirth"} or \code{by="generation"} sorting is performed via
\code{\link{order}} and its arguments \code{na.last} and
\code{decreasing} can be used. With \code{by="pedigree"} argument
\code{decreasing} has an effect.

Generation values can have different meaning i.e. values might either
increase or decrease from ascendants to descendant with the same
meaning. This information is stored in attribute \code{generationOrder}
(at the time of creating the pedigree object via \code{\link{Pedigree}})
and used for determining the order of sorting if sorting is by
generation. The output of the result might therefore be opposite of what
user might expect. If that is the case, use argument \code{decreasing}
as defined in \code{\link{order}}. Look also into examples bellow.

}

\value{Sorted pedigree}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}} and \code{\link{order}}}

\examples{
  ped <- generatePedigree(nId=5)
  ped <- ped[sample(1:nrow(ped)), ]
  sort(ped)
  ## sort(ped, by="dtBirth")       ## TODO
  sort(ped, by="generation")
  ## try(sort(ped, by="pedigree")) ## TODO

  ## Sorting with decreasing generation values from ascendants to descendants
  ped1 <- generatePedigree(nId=5, generationOrder="decreasing")
  sort(ped1, by="generation")
  sort(ped1, decreasing=TRUE, by="generation")
  sort(ped1, decreasing=FALSE, by="generation")

  ## Sorting with unknown values
  ped[1, "generation"] <- NA
  sort(ped, na.last=TRUE, by="generation")
  sort(ped, na.last=FALSE, by="generation")
  sort(ped, na.last=NA, by="generation")
}

\keyword{misc}

%--------------------------------------------------------------------------
% sort.pedigree.Rd ends here

% generatePedigree.Rd
%--------------------------------------------------------------------------
% What: Generate pedigree example man page
% $Id: generatePedigree.Rd 1092 2006-11-12 12:28:38Z ggorjan $
% Time-stamp: <2006-09-30 01:39:14 ggorjan>
%--------------------------------------------------------------------------

\name{generatePedigree}

\alias{generatePedigree}

\title{Generate Pedigree example}

\description{\code{generatePedigree} creates nonoverlapping pedigree
  example, which can be used for demos and code testing.
}

\usage{generatePedigree(nId, nGeneration=3, nFather=round(nId/3),
  nMother=nId - nFather, start=1, generationOrder="increasing",
  colClass="integer")}

\arguments{
  \item{nId}{integer, number of individuals per generation, at least 2}
  \item{nGeneration}{integer, number of generations}
  \item{nFather}{integer, number of fathers per generation}
  \item{nMother}{integer, number of mothers per generation}
  \item{start}{first generation value}
  \item{generationOrder}{character, generation value is "increasing" or
    "decreasing" through generations}
  \item{colClass}{character, class for columns: "integer" or "factor"}
}

\value{
  An extended, sorted and possibly coded pedigree object with
  following columns: id, father, mother, generation and sex.
}

\references{Rico Gutierrez, M. (1999) Los modelos lineales en la mejora
  genetica animal. Ediciones Peninsular. ISBN 84-605-9910-8.}

\author{Marcos Rico Gutierrez (author of MATLAB code) and Gregor Gorjanc
  (R implementation)}

\seealso{\code{\link{Pedigree}}}

\examples{
  generatePedigree(5)
  generatePedigree(nId=5, nGeneration=4, nFather=1, nMother=2)
  generatePedigree(nId=5, nGeneration=4, nFather=1, nMother=2,
                   start=0, generationOrder="decreasing")
  generatePedigree(nId=100, nGeneration=20, nFather=10, nMother=50)
}

\keyword{manip}
\keyword{misc}

%--------------------------------------------------------------------------
% generatePedigree.Rd ends here

% founder.Rd
%--------------------------------------------------------------------------
% What: Founder and non-founder individuals in the pedigree
% $Id: founder.Rd 1097 2006-11-14 06:10:43Z ggorjan $
% Time-stamp: <2006-10-09 17:13:05 ggorjan>
%--------------------------------------------------------------------------

\name{isFounder}

\alias{isFounder}

\concept{founders}
\concept{base indiviual}

\title{Founder and non-founder individuals in the pedigree}

\description{

\code{isFounder} classifies individuals in the pedigree as founders
(base) or non-founders (non-base individuals).

}

\usage{
  isFounder(x, col=attr(x, ".ascendant"))
}

\arguments{
  \item{x}{pedigree object}
  \item{col}{character, which columns should be checked, see examples}
}

\details{

By definition founders do not have any known ascendants, while the
opossite is the case for non-founders i.e. they have at least one known
ascendant.

FIXME: any relation with founderGeneSet in GeneticsBase

}

\value{Boolean vector.}

\author{Gregor Gorjanc}

\seealso{\code{\link{Pedigree}}}

\examples{
  ped <- generatePedigree(nId=5)
  isFounder(ped)
  ## Based only on fathers
  isFounder(ped, col=c("father"))
  ## Works also only on a part of a pedigree
  isFounder(ped[1:5, ])
}

\keyword{misc}

%--------------------------------------------------------------------------
% founder.Rd ends here
